$Title Sets Definition
$ontext
--------------------------------------------------------------------------------
------------------------------ General Header ----------------------------------
--------------------------------------------------------------------------------
         SAM disaggregation in load blocks
         Renato Rodrigues
         Instituto de Investigacin Tecnolgica
         Date: 06, oct, 2011
--------------------------------------------------------------------------------
--------------------------- End of General Header ------------------------------
--------------------------------------------------------------------------------
$offtext

Parameter report_iterative_deviations(iterations,*,*);

if (exec_MinMax=1 or exec_MinMax_plus_lineal_term=1, report_iterative_deviations(iter_executed,"max_deviation","Max_deviation_by_iteration")=max_deviation(iter_executed); );
report_iterative_deviations(iter_executed,"oem_vom","Deviation_by_iteration")= oem_vom_dev(iter_executed);
report_iterative_deviations(iter_executed,"oem_fom_labor","Deviation_by_iteration") = oem_fom_labor_dev(iter_executed);
report_iterative_deviations(iter_executed,"oem_fom_social_contribution","Deviation_by_iteration") = oem_fom_social_contribution_dev(iter_executed);
report_iterative_deviations(iter_executed,"oem_fom_equipments","Deviation_by_iteration") = oem_fom_equipments_dev(iter_executed);
report_iterative_deviations(iter_executed,"thermodynamic_efficiency","Deviation_by_iteration") = thermodynamic_efficiency_dev(iter_executed);
report_iterative_deviations(iter_executed,"own_cons_gen_pctg","Deviation_by_iteration") = own_cons_gen_pctg_dev(iter_executed);
report_iterative_deviations(iter_executed,"overnight_costs","Deviation_by_iteration") = overnight_costs_dev(iter_executed);
report_iterative_deviations(iter_executed,"tdeo_losses_pctg","Deviation_by_iteration") = tdeo_losses_pctg_dev(iter_executed);
report_iterative_deviations(iter_executed,"exp_price_pctg","Deviation_by_iteration") = exp_price_pctg_dev(iter_executed);
report_iterative_deviations(iter_executed,"imp_price_pctg","Deviation_by_iteration") = imp_price_pctg_dev(iter_executed);
report_iterative_deviations(iter_executed,"tdeo_pf_pct_adj","Deviation_by_iteration") = tdeo_pf_pct_adj_dev(iter_executed);
report_iterative_deviations(iter_executed,"co2e_content","Deviation_by_iteration") = co2e_content_dev(iter_executed);

report_iterative_deviations(iter_executed,"oem_vom","Total_Deviation") = total_oem_vom_dev(iter_executed);
report_iterative_deviations(iter_executed,"oem_fom_labor","Total_Deviation") = total_oem_fom_labor_dev(iter_executed);
report_iterative_deviations(iter_executed,"oem_fom_social_contribution","Total_Deviation") = total_oem_fom_social_contribution_dev(iter_executed);
report_iterative_deviations(iter_executed,"oem_fom_equipments","Total_Deviation") = total_oem_fom_equipments_dev(iter_executed);
report_iterative_deviations(iter_executed,"thermodynamic_efficiency","Total_Deviation") = total_thermodynamic_efficiency_dev(iter_executed);
report_iterative_deviations(iter_executed,"own_cons_gen_pctg","Total_Deviation") = total_own_cons_gen_pctg_dev(iter_executed);
report_iterative_deviations(iter_executed,"overnight_costs","Total_Deviation") = total_overnight_costs_dev(iter_executed);
report_iterative_deviations(iter_executed,"tdeo_losses_pctg","Total_Deviation") = total_tdeo_losses_pctg_dev(iter_executed);
report_iterative_deviations(iter_executed,"exp_price_pctg","Total_Deviation") = total_exp_price_pctg_dev(iter_executed);
report_iterative_deviations(iter_executed,"imp_price_pctg","Total_Deviation") = total_imp_price_pctg_dev(iter_executed);
report_iterative_deviations(iter_executed,"tdeo_pf_pct_adj","Total_Deviation") = total_tdeo_pf_pct_adj_dev(iter_executed);
report_iterative_deviations(iter_executed,"co2e_content","Total_Deviation") = total_co2e_content_dev(iter_executed);

report_iterative_deviations(iter_executed,"oem_vom","Average_Deviations") = average_oem_vom_dev(iter_executed);
report_iterative_deviations(iter_executed,"oem_fom_labor","Average_Deviations") = average_oem_fom_labor_dev(iter_executed);
report_iterative_deviations(iter_executed,"oem_fom_social_contribution","Average_Deviations") = average_oem_fom_social_contribution_dev(iter_executed);
report_iterative_deviations(iter_executed,"oem_fom_equipments","Average_Deviations") = average_oem_fom_equipments_dev(iter_executed);
report_iterative_deviations(iter_executed,"thermodynamic_efficiency","Average_Deviations") = average_thermodynamic_efficiency_dev(iter_executed);
report_iterative_deviations(iter_executed,"own_cons_gen_pctg","Average_Deviations") = average_own_cons_gen_pctg_dev(iter_executed);
report_iterative_deviations(iter_executed,"overnight_costs","Average_Deviations") = average_overnight_costs_dev(iter_executed);
report_iterative_deviations(iter_executed,"tdeo_losses_pctg","Average_Deviations") = average_tdeo_losses_pctg_dev(iter_executed);
report_iterative_deviations(iter_executed,"exp_price_pctg","Average_Deviations") = average_exp_price_pctg_dev(iter_executed);
report_iterative_deviations(iter_executed,"imp_price_pctg","Average_Deviations") = average_imp_price_pctg_dev(iter_executed);
report_iterative_deviations(iter_executed,"tdeo_pf_pct_adj","Average_Deviations") = average_tdeo_pf_pct_adj_dev(iter_executed);
report_iterative_deviations(iter_executed,"co2e_content","Average_Deviations") = average_co2e_content_dev(iter_executed);

report_iterative_deviations(iter_executed,"oem_vom","Deviation_Concentration_on_Variables") = concentration_oem_vom_dev(iter_executed);
report_iterative_deviations(iter_executed,"oem_fom_labor","Deviation_Concentration_on_Variables") = concentration_oem_fom_labor_dev(iter_executed);
report_iterative_deviations(iter_executed,"oem_fom_social_contribution","Deviation_Concentration_on_Variables") = concentration_oem_fom_social_contribution_dev(iter_executed);
report_iterative_deviations(iter_executed,"oem_fom_equipments","Deviation_Concentration_on_Variables") = concentration_oem_fom_equipments_dev(iter_executed);
report_iterative_deviations(iter_executed,"thermodynamic_efficiency","Deviation_Concentration_on_Variables") = concentration_thermodynamic_efficiency_dev(iter_executed);
report_iterative_deviations(iter_executed,"own_cons_gen_pctg","Deviation_Concentration_on_Variables") = concentration_own_cons_gen_pctg_dev(iter_executed);
report_iterative_deviations(iter_executed,"overnight_costs","Deviation_Concentration_on_Variables") = concentration_overnight_costs_dev(iter_executed);
report_iterative_deviations(iter_executed,"tdeo_losses_pctg","Deviation_Concentration_on_Variables") = concentration_tdeo_losses_pctg_dev(iter_executed);
report_iterative_deviations(iter_executed,"exp_price_pctg","Deviation_Concentration_on_Variables") = concentration_exp_price_pctg_dev(iter_executed);
report_iterative_deviations(iter_executed,"imp_price_pctg","Deviation_Concentration_on_Variables") = concentration_imp_price_pctg_dev(iter_executed);
report_iterative_deviations(iter_executed,"tdeo_pf_pct_adj","Deviation_Concentration_on_Variables") = concentration_tdeo_pf_pct_adj_dev(iter_executed);
report_iterative_deviations(iter_executed,"co2e_content","Deviation_Concentration_on_Variables") = concentration_co2e_content_dev(iter_executed);



*---------Declaration of auxiliary file-------
file TMPXX /tmpxx.txt/
put TMPXX  putclose
                         'par=report_iterative_deviations rng=Deviations_by_iteration!D6 Rdim=2'

*---------GAMs loading data-------------------
execute_unload "results.gdx"

*---------GAMs loading data-------------------
execute        'gdxxrw.exe results.gdx o="Output_Model_%Model%_%Load_Block_Aggregation%_%Calibration_Problem%_%Years_Simulated%_SAM_Disaggregation.xlsx" SQ=n Squeeze=0 EpsOut=0 @tmpxx.txt'


*---------Deleting Auxiliary Files--
execute 'del tmpxx.txt results.gdx';


*Plotting the deviations
set dev_list /oem_vom, oem_fom_labor, oem_fom_social_contribution, oem_fom_equipments, thermodynamic_efficiency, own_cons_gen_pctg, overnight_costs, tdeo_losses_pctg, exp_price_pctg, imp_price_pctg, tdeo_pf_pct_adj, co2e_content/;
parameter report1(iterations,*),report2(iterations,*),report3(iterations,*),report4(iterations,*);
loop(dev_list, report1(iter_executed,dev_list)=report_iterative_deviations(iter_executed,dev_list,"Total_Deviation"););
$setglobal labels iter
$setglobal gp_opt1 "set data style linespoints"
$setglobal gp_opt2 "set title 'Total deviation on variables of SAM disagregation calibration'"
$setglobal gp_opt3 "set xlabel 'Iteration'"
$setglobal gp_opt4 "set ylabel 'Deviation (%)'"
$libinclude plot report1



$ontext
loop(dev_list, report1(iter_executed,dev_list)=report_iterative_deviations(iter_executed,dev_list,"Deviation_by_iteration"););
$setglobal labels iter
$setglobal gp_opt1 "set data style linespoints"
$setglobal gp_opt2 "set title 'Max deviation on variables of SAM disagregation calibration'"
$setglobal gp_opt3 "set xlabel 'Iteration'"
$setglobal gp_opt4 "set ylabel 'Deviation (%)'"
$libinclude plot results2
$ontext

$ontext
loop(dev_list, report3(iter_executed,dev_list)=report_iterative_deviations(iter_executed,dev_list,"Average_Deviations"););
$setglobal labels iter
$setglobal gp_opt1 "set data style linespoints"
$setglobal gp_opt2 "set title 'Average deviation on variables of SAM disagregation calibration'"
$setglobal gp_opt3 "set xlabel 'Iteration'"
$setglobal gp_opt4 "set ylabel 'Average Deviation (%)'"
$libinclude plot results3

loop(dev_list, report4(iter_executed,dev_list)=report_iterative_deviations(iter_executed,dev_list,"Deviation_Concentration_on_Variables"););
$setglobal labels iter
$setglobal gp_opt1 "set data style linespoints"
$setglobal gp_opt2 "set title 'Deviation concentration on variables of SAM disagregation calibration'"
$setglobal gp_opt3 "set xlabel 'Iteration'"
$setglobal gp_opt4 "set ylabel 'Concentration (%)'"
$libinclude plot results4
$offtext
