$Title Sets Definition
$ontext
--------------------------------------------------------------------------------
------------------------------ General Header ----------------------------------
--------------------------------------------------------------------------------
         GEMED - Pure Top-down Electricity Extended CGE Model
         Renato Rodrigues
         Instituto de Investigacin Tecnolgica
         Date: 17, aug, 2011
--------------------------------------------------------------------------------
--------------------------- End of General Header ------------------------------
--------------------------------------------------------------------------------
$offtext


*-------------------------------------------------------------------------------
*---------------------------------- Parameters ---------------------------------
*-------------------------------------------------------------------------------
*Exogenously parameters defined in exogenous_parameters.gms
$ontext
elasticity_va(sne)                       p.u.            [0.2:1.7]       Elasticity of substitution between productive factors of non-electricity sector sne
elasticity_d(gne)                        p.u.            [2.8:1.9]       Elasticity of substitution between imported and domestic produced non-electricity good gne
elasticity_q(gne)                        p.u.            [2.0:2.0]       Elasticity of transformation between domestic and external destined supply
p_m_initial(ey,gne)                      1x10^6         [1.0:1.0]       International price of the imported non-electricity good gne
p_ex_initial(ey,gne)                     1x10^6         [1.0:1.0]       International price of exported non-electricity good gne
mu_cpi(ey,gne)                           %               [0.143:0.143]   Weight of non-electricity good gne on consumer price index
tx_rate_sc(ey,pf,sne)                    %               [0.280:0.397]   Social contribution tax rate
tx_rate(ey,sam,tx)                       %               [-0.017:0.109]  Tax rate (production and product taxes)
q_m_GEN(ey,l,p,b)                                        [0.020:0.929]
q_ex_GEN(ey,l,p,b)                                       [0.024:1.389]
e_ii_s(samyear,g,s)                      millions       [0.1:92784.1]   parameter from SAM table
e_pf_s(samyear,pf,s)                     millions       [60.3:102997.0] parameter from SAM table
e_tx_sam(samyear,tx,sam)                 millions       [-1116.0:60626.2] parameter from SAM table
e_m_s(samyear,s)                         millions                       parameter from SAM table
e_g_i(samyear,g,i)                       millions                       parameter from SAM table
e_i_tx(samyear,i,tx)                     millions                       parameter from SAM table
e_transf_i(samyear,i,i2)                 millions                       parameter from SAM table
e_transf_k_i_ext(samyear,i)              millions                       parameter from SAM table
e_i_pf(samyear,i,pf)                     millions                       parameter from SAM table
e_i_sav(samyear,i)                       millions                       parameter from SAM table
e_inv(samyear,g)                         millions                       parameter from SAM table
e_sav(samyear)                           millions                       parameter from SAM table
e_g_ex(samyear,g)                        millions                       parameter from SAM table
e_transf_k_ext_i(samyear,i)              millions                       parameter from SAM table
e_transf_k_ext_spain(samyear)            millions                       parameter from SAM table

*Exogenously parameters defined in other model
E_II_QE_GEN_SAMDIS(y,gne,l,gp,gb,t)      millions 
E_II_EE_GEN_SAMDIS(y,l,dp,db,gp,gb,t)    millions 
E_F_E_GEN_SAMDIS(y,pf,l,gp,gb,t)         millions 
E_TAX_E_GEN_SAMDIS(y,tx,l,gp,gb,t)       millions 
E_M_E_GEN_SAMDIS(y,l,gp,gb)              millions 
E_II_EQ_ENERGY_SAMDIS(y,sne,l,dp,db)     millions 
E_I_ENERGY_SAMDIS(y,i,l,dp,db)           millions 
E_EX_ENERGY_SAMDIS(y,l,dp,db)            millions 
E_II_QE_TDeO_SAMDIS(y,gne)               millions 
E_II_EE_TDeO_SAMDIS(y,l,dp,db)           millions 
E_F_E_TDeO_SAMDIS(y,pf)                  millions 
E_TAX_E_TDeO_SAMDIS(y,tx)                millions 
E_M_E_TDeO_SAMDIS(y)                     millions 
E_II_EQ_POWER_SAMDIS(y,sne)              millions 
E_I_POWER_SAMDIS(y,i)                    millions 
E_EX_POWER_SAMDIS(y)                     millions 
mkt_surplus(ey,l,p,b)                    millions 
$offtext

*remaining parameters exclusive to this model

parameter emissions_allowance(ey,l,p,b,t) distributing emissions allowances by each load block according to the technology use (or total PGEN of the load block if the BU model disconsider one technology);
emissions_allowance(ey,l,p,b,t) = ( co2_emission_rights_assignment_GEN_technology(ey,t)*co2_price(ey)* ( sum(f, pgen_SAMDIS(ey,t,f,l,p,b)*duration(l,p,b))/sum((f,p_alias,b_alias), pgen_SAMDIS(ey,t,f,l,p_alias,b_alias)*duration(l,p_alias,b_alias)) ) )$ ( NOT (sum((f,p_alias,b_alias)$emitting_t(t,f),pgen_SAMDIS(ey,t,f,l,p_alias,b_alias))=0) ) + ( co2_emission_rights_assignment_GEN_technology(ey,t)*co2_price(ey)* ( sum((t_alias,f), pgen_SAMDIS(ey,t_alias,f,l,p,b)*duration(l,p,b))/sum((t_alias,f,p_alias,b_alias), pgen_SAMDIS(ey,t_alias,f,l,p_alias,b_alias)*duration(l,p_alias,b_alias)) ) ) $ ( sum((f,p_alias,b_alias)$emitting_t(t,f),pgen_SAMDIS(ey,t,f,l,p_alias,b_alias))=0 );

Parameters
c_h(ey,gne)              %       Representative household marginal propensity to consume domestic non-electricity good gne
c_h_GEN(ey,l,p,b)        %
c_h_TDeO(ey)             %
q_i_pf(ey,i,pf)                  Quantity of production factor pf owned by institution i (households or government)
s_propensity_h(ey)               Representative Household marginal propensity to save
tx_rate_sc_TDeO(ey,pf)           Social contribution tax rate
tx_rate_sc_tech(ey,pf,l,p,b,t)   Social contribution tax rate
tx_rate_TDeO(ey,tx)              Tax rate (production and product taxes)
tx_rate_tech(ey,l,p,b,t,tx)      Product tax rate
tx_rate_GEN(ey,l,p,b,tx)         Production tax rate
emission_rate_GEN(ey,l,p,b,t) MMtCO2e:Q_S_TECH CO2e emission rate by load block and technology
psc_h(ey)                        Proportion of annual social contribution payments reverted directly to households
transf_g_h(ey)                   Net transfers from the government to the households
transf_ext_g(ey)                 Net transfers from the exterior to the government
transf_ext_h(ey)                 Net transfers from the exterior to the households
transf_ext_k(ey)                 Net capital transfers from the exterior
a_va_pf(ey,pf,sne)               Share parameter of product factor on value added composite non-electricity good production function
alpha_va(ey,sne)                 Productivity parameter of non-electricity sector value added composite good production function
c_ii_share(ey,gne,sne)           Share parameter of non-electricity intermediate composite inputs gne used on on-electricity sector sne production function
c_ii_share_GEN(ey,l,p,b,sne)
c_ii_share_TDeO(ey,sne)
c_va_share(ey,sne)               Share parameter of value added composite input used on non-electricity sector sne production function
a_d_q(ey,gne)                    Share parameter of domestic produced supply on non-electricity sector Armington aggregate
a_d_m(ey,gne)                    Share parameter of imports supply on non-electricity sector Armington aggregate
alpha_d(ey,gne)                  Productivity parameter of Armington aggregated imported and domestic produced supply of non-electricity good gne
b_q_q(ey,gne)                    Share parameter of CET domestically destined non-electricity good gne
b_q_ex(ey,gne)                   Share parameter of CET exportation destined non-electricity good gne
beta_q(ey,gne)                   Productivity parameter of CET export and domestically destined non-electricity good gne
c_pf_TDeO_share(ey,pf)
c_ii_gne_TDeO(ey,gne)
c_ii_elec_TDeO(ey,l,dp,db)
c_ii_TDeO_TDeO(ey)
c_va_TDeO_share(ey)
c_pf_tech_share(ey,pf,l,p,b,t)
c_ii_gne_GEN(ey,gne,l,p,b,t)
c_ii_elec_GEN(ey,l,dp,db,gp,gb,t)
c_ii_TDeO_GEN(ey,l,gp,gb,t)
c_va_tech_share(ey,l,p,b,t)
c_ii_tech_GEN(ey,l,gp,gb,t)
p_m_GEN(ey,l,p,b)
q_m_GEN(ey,l,p,b)
q_ex_GEN(ey,l,p,b)
p_ex_GEN(ey,l,p,b)
q_gov_initial(ey,gne)            Government initial demand for non-electricity good gne
q_gov_GEN_initial(ey,l,p,b)
q_gov_TDeO_initial(ey)
Theta(ey,gne)                    Share parameter of demand for investment non-electricity good gne
mu_cpi_GEN(ey,l,p,b)
mu_cpi_TDeO(ey)
;

*Initial Variable Values
Parameters
initial_Q_H_D_GEMED(y,gne)
initial_Q_H_D_GEN_GEMED(y,l,p,b)
initial_Q_H_D_TDeO_GEMED(y)
initial_P_PF_LABOR_GEMED(y)      1x10^6 
initial_P_PF_CAPITAL_GEMED(y)    1x10^6 
initial_Y_H_GEMED(y)             millions 
initial_Q_PF_SNE_LABOR_GEMED(y,sne)
initial_Q_PF_SNE_CAPITAL_GEMED(y,sne)
initial_Q_VA_GEMED(y,sne)
initial_P_VA_GEMED(y,sne)        1x10^6 
initial_Q_II_GEMED(y,gne,sne)
initial_Q_II_GEN_SNE_GEMED(y,l,p,b,sne)
initial_Q_II_TDeO_SNE_GEMED(y,sne)
initial_Q_S_GEMED(y,sne)
initial_P_S_GEMED(y,gne)         1x10^6 
initial_Q_M_GEMED(y,gne)
initial_Q_D_GEMED(y,gne)
initial_P_D_GEMED(y,gne)         1x10^6 
initial_Q_EX_GEMED(y,gne)
initial_Q_Q_GEMED(y,gne)
initial_P_Q_GEMED(y,gne)         1x10^6 
initial_Q_PF_LABOR_TDeO_GEMED(y)
initial_Q_PF_CAPITAL_TDeO_GEMED(y)
initial_Q_VA_TDeO_GEMED(y)
initial_P_VA_TDeO_GEMED(y)       1x10^6 
initial_Q_II_GNE_TDeO_GEMED(y,gne)
initial_Q_II_GEN_TDeO_GEMED(y,l,dp,db)
initial_Q_II_TDeO_TDeO_GEMED(y)
initial_Q_S_TDeO_GEMED(y)
initial_P_S_TDeO_GEMED(y)        1x10^6 
initial_Q_D_TDeO_GEMED(y)
initial_P_D_TDeO_GEMED(y)        1x10^6 
initial_Q_Q_TDeO_GEMED(y)
initial_P_Q_TDeO_GEMED(y)        1x10^6 
initial_Q_PF_LABOR_GEN_tech_GEMED(y,l,p,b,t)
initial_Q_PF_CAPITAL_GEN_tech_GEMED(y,l,p,b,t)
initial_Q_VA_GEN_tech_GEMED(y,l,p,b,t)
initial_P_VA_GEN_tech_GEMED(y,l,p,b,t) 1x10^6 
initial_Q_II_GNE_GEN_tech_GEMED(y,gne,l,p,b,t)
initial_Q_II_GEN_GEN_tech_GEMED(y,l,dp,db,gp,gb,t)
initial_Q_II_TDeO_GEN_tech_GEMED(y,l,p,b,t)
initial_Q_S_GEN_GEMED(y,l,p,b)
initial_P_S_GEN_GEMED(y,l,p,b)   1x10^6 
initial_Q_S_TECH_GEMED(y,l,p,b,t)
initial_P_S_TECH_GEMED(y,l,p,b,t) 1x10^6 
initial_Q_D_GEN_GEMED(y,l,p,b)
initial_P_D_GEN_GEMED(y,l,p,b)   1x10^6 
initial_Q_Q_GEN_GEMED(y,l,p,b)
initial_P_Q_GEN_GEMED(y,l,p,b)   1x10^6 
initial_Y_G_GEMED(y)             millions 
initial_E_G_GEMED(y)             millions 
initial_Y_TAX_GEMED(y)           millions 
initial_S_TOTAL_GEMED(y)         millions 
initial_S_TOTAL_H_GEMED(y)       millions 
initial_S_TOTAL_G_GEMED(y)       millions 
initial_S_TOTAL_EXT_GEMED(y)     millions 
initial_I_TOTAL_GEMED(y)         millions 
initial_Q_I_D_GEMED(y,gne)
initial_CPI_GEMED(y)
;

initial_P_PF_LABOR_GEMED(ey)=p_pf_initial(ey,"Labor");
initial_P_PF_CAPITAL_GEMED(ey)=p_pf_initial(ey,"Capital");
initial_P_VA_GEMED(ey,sne)=p_va_initial(ey,sne);
initial_P_S_GEMED(ey,gne)=p_s_initial(ey,gne);
initial_P_D_GEMED(ey,gne)=p_d_initial(ey,gne);
initial_P_Q_GEMED(ey,gne)=p_q_initial(ey,gne);
initial_P_VA_TDeO_GEMED(ey)=1;
initial_P_S_TDeO_GEMED(ey)=1;


initial_Q_S_GEN_GEMED(ey,l,p,b)$duration(l,p,b) = sum(t,sum(f, PGEN_LEGEN.l(ey,t,f,l,p,b)))*duration(l,p,b)/1e6;
initial_Q_S_TECH_GEMED(ey,l,p,b,t)$duration(l,p,b) = initial_Q_S_GEN_GEMED(ey,l,p,b) * ( sum(pf, E_F_E_GEN_SAMDIS.l(ey,pf,l,p,b,t)) + E_TAX_E_GEN_SAMDIS.l(ey,"Social_Contributions",l,p,b,t) + sum(gne, E_II_QE_GEN_SAMDIS.l(ey,gne,l,p,b,t)) + sum((dp,db), E_II_EE_GEN_SAMDIS.l(ey,l,dp,db,p,b,t)) + 0 ) / sum(t_alias, ( sum(pf, E_F_E_GEN_SAMDIS.l(ey,pf,l,p,b,t_alias)) + E_TAX_E_GEN_SAMDIS.l(ey,"Social_Contributions",l,p,b,t_alias) + sum(gne, E_II_QE_GEN_SAMDIS.l(ey,gne,l,p,b,t_alias)) + sum((dp,db),E_II_EE_GEN_SAMDIS.l(ey,l,dp,db,p,b,t_alias)) + 0 ));
initial_P_S_TECH_GEMED(ey,l,p,b,t)$initial_Q_S_TECH_GEMED(ey,l,p,b,t) = ( sum(pf, E_F_E_GEN_SAMDIS.l(ey,pf,l,p,b,t)) + E_TAX_E_GEN_SAMDIS.l(ey,"Social_Contributions",l,p,b,t) + sum(gne, E_II_QE_GEN_SAMDIS.l(ey,gne,l,p,b,t)) + sum((dp,db),E_II_EE_GEN_SAMDIS.l(ey,l,dp,db,p,b,t)) + 0 + E_TAX_E_GEN_SAMDIS.l(ey,"Product_Tax",l,p,b,t) + E_TAX_E_GEN_SAMDIS.l(ey,"CO2_Payments",l,p,b,t) ) / initial_Q_S_TECH_GEMED(ey,l,p,b,t);
initial_P_S_GEN_GEMED(ey,l,p,b)$initial_Q_S_GEN_GEMED(ey,l,p,b) = ( sum(t, initial_P_S_TECH_GEMED(ey,l,p,b,t)*initial_Q_S_TECH_GEMED(ey,l,p,b,t)) - sum(t, emissions_allowance(ey,l,p,b,t)))  / initial_Q_S_GEN_GEMED(ey,l,p,b);
q_m_GEN(ey,l,p,b)=pimported(ey,l,p,b)*duration(l,p,b)/1e6;
q_ex_GEN(ey,l,p,b)=demand(ey,"Exports",l,p,b)*duration(l,p,b)/1e6;
p_m_GEN(ey,l,p,b)$duration(l,p,b)=E_M_E_GEN_SAMDIS.l(ey,l,p,b)/q_m_GEN(ey,l,p,b);
p_ex_GEN(ey,l,p,b)$duration(l,p,b)=E_EX_ENERGY_SAMDIS.l(ey,l,p,b)/q_ex_GEN(ey,l,p,b);
initial_Q_D_GEN_GEMED(ey,l,p,b)$duration(l,p,b)=initial_Q_S_GEN_GEMED(ey,l,p,b)+q_m_GEN(ey,l,p,b);
initial_P_D_GEN_GEMED(ey,l,p,b)$initial_Q_D_GEN_GEMED(ey,l,p,b)=( initial_Q_S_GEN_GEMED(ey,l,p,b)*initial_P_S_GEN_GEMED(ey,l,p,b) + sum(t, E_TAX_E_GEN_SAMDIS.l(ey,"Production_Taxes",l,p,b,t)) + E_M_E_GEN_SAMDIS.l(ey,l,p,b) ) / initial_Q_D_GEN_GEMED(ey,l,p,b);
initial_P_VA_GEN_tech_GEMED(ey,l,p,b,t)$initial_Q_S_TECH_GEMED(ey,l,p,b,t)=1;
initial_Q_PF_SNE_LABOR_GEMED(ey,sne)=e_pf_s(ey,"Labor",sne)/p_pf_initial(ey,"Labor");
initial_Q_PF_SNE_CAPITAL_GEMED(ey,sne)=e_pf_s(ey,"Capital",sne)/p_pf_initial(ey,"Capital");
initial_Q_VA_GEMED(ey,sne)=( initial_Q_PF_SNE_LABOR_GEMED(ey,sne)*initial_P_PF_LABOR_GEMED(ey) + initial_Q_PF_SNE_CAPITAL_GEMED(ey,sne)*initial_P_PF_CAPITAL_GEMED(ey) + e_tx_sam(ey,"Social_Contributions",sne) ) / initial_P_VA_GEMED(ey,sne);
initial_Q_II_GEMED(ey,gne,sne)= e_ii_s(ey,gne,sne)/initial_P_Q_GEMED(ey,gne);
initial_Q_S_GEMED(ey,sne)= ( initial_Q_VA_GEMED(ey,sne)*initial_P_VA_GEMED(ey,sne) + sum(gne, e_ii_s(ey,gne,sne)) + sum((l,p,b), E_II_EQ_ENERGY_SAMDIS.l(ey,sne,l,p,b)) + E_II_EQ_POWER_SAMDIS.l(ey,sne) + e_tx_sam(ey,"Product_Tax",sne) - sum(i, e_transf_i_s(ey,i,sne))) / ( initial_P_S_GEMED(ey,sne)-emission_rate(ey,sne)*co2_price(ey) );
initial_Q_M_GEMED(ey,gne)= e_m_s(ey,gne) / p_m_initial(ey,gne);
initial_Q_D_GEMED(ey,gne)=( initial_Q_S_GEMED(ey,gne)*initial_P_S_GEMED(ey,gne) + e_tx_sam(ey,"Production_Taxes",gne) + initial_Q_M_GEMED(ey,gne)*p_m_initial(ey,gne) ) / initial_P_D_GEMED(ey,gne);
initial_Q_EX_GEMED(ey,gne)=e_g_ex(ey,gne)/p_ex_initial(ey,gne);
initial_Q_Q_GEMED(ey,gne)=( initial_Q_D_GEMED(ey,gne)*initial_P_D_GEMED(ey,gne) - initial_Q_EX_GEMED(ey,gne)*p_ex_initial(ey,gne) ) / initial_P_Q_GEMED(ey,gne);

initial_Q_PF_LABOR_TDeO_GEMED(ey)=E_F_E_TDeO_SAMDIS.l(ey,"Labor")/p_pf_initial(ey,"Labor");
initial_Q_PF_CAPITAL_TDeO_GEMED(ey)=E_F_E_TDeO_SAMDIS.l(ey,"Capital")/p_pf_initial(ey,"Capital");
initial_Q_VA_TDeO_GEMED(ey)=( initial_Q_PF_LABOR_TDeO_GEMED(ey)*initial_P_PF_LABOR_GEMED(ey) + initial_Q_PF_CAPITAL_TDeO_GEMED(ey)*initial_P_PF_CAPITAL_GEMED(ey) + E_TAX_E_TDeO_SAMDIS.l(ey,"Social_Contributions") ) / initial_P_VA_TDeO_GEMED(ey);
initial_Q_II_GNE_TDeO_GEMED(ey,gne)=E_II_QE_TDeO_SAMDIS.l(ey,gne)/initial_P_Q_GEMED(ey,gne);
initial_Q_S_TDeO_GEMED(ey)= ( initial_Q_VA_TDeO_GEMED(ey)*initial_P_VA_TDeO_GEMED(ey) + sum(gne, E_II_QE_TDeO_SAMDIS.l(ey,gne)) + sum((l,p,b), E_II_EE_TDeO_SAMDIS.l(ey,l,p,b)) + 0 + E_TAX_E_TDeO_SAMDIS.l(ey,"Product_Tax") ) / initial_P_S_TDeO_GEMED(ey);
initial_Q_D_TDeO_GEMED(ey)=initial_Q_S_TDeO_GEMED(ey);
initial_P_D_TDeO_GEMED(ey)=( initial_Q_S_TDeO_GEMED(ey)*initial_P_S_TDeO_GEMED(ey) + E_TAX_E_TDeO_SAMDIS.l(ey,"Production_Taxes") ) / initial_Q_D_TDeO_GEMED(ey);
initial_Q_Q_TDeO_GEMED(ey)=initial_Q_D_TDeO_GEMED(ey);
initial_P_Q_TDeO_GEMED(ey)=( initial_Q_D_TDeO_GEMED(ey)*initial_P_D_TDeO_GEMED(ey) ) / initial_Q_Q_TDeO_GEMED(ey);
initial_Q_II_TDeO_SNE_GEMED(ey,sne)=E_II_EQ_POWER_SAMDIS.l(ey,sne)/initial_P_Q_TDeO_GEMED(ey);
initial_Q_II_TDeO_TDeO_GEMED(ey)=0;

initial_Q_II_TDeO_GEN_tech_GEMED(ey,l,p,b,t)=0;
initial_Q_PF_LABOR_GEN_tech_GEMED(ey,l,p,b,t)$initial_Q_S_TECH_GEMED(ey,l,p,b,t)=E_F_E_GEN_SAMDIS.l(ey,"Labor",l,p,b,t)/p_pf_initial(ey,"Labor");
initial_Q_PF_CAPITAL_GEN_tech_GEMED(ey,l,p,b,t)$initial_Q_S_TECH_GEMED(ey,l,p,b,t)=E_F_E_GEN_SAMDIS.l(ey,"Capital",l,p,b,t)/p_pf_initial(ey,"Capital");
initial_Q_VA_GEN_tech_GEMED(ey,l,p,b,t)$initial_Q_S_TECH_GEMED(ey,l,p,b,t)=( initial_Q_PF_LABOR_GEN_tech_GEMED(ey,l,p,b,t)*initial_P_PF_LABOR_GEMED(ey) + initial_Q_PF_CAPITAL_GEN_tech_GEMED(ey,l,p,b,t)*initial_P_PF_CAPITAL_GEMED(ey) + E_TAX_E_GEN_SAMDIS.l(ey,"Social_Contributions",l,p,b,t) ) / initial_P_VA_GEN_tech_GEMED(ey,l,p,b,t);
initial_Q_II_GNE_GEN_tech_GEMED(ey,gne,l,p,b,t)$initial_Q_S_TECH_GEMED(ey,l,p,b,t)=E_II_QE_GEN_SAMDIS.l(ey,gne,l,p,b,t)/initial_P_Q_GEMED(ey,gne);
initial_Q_Q_GEN_GEMED(ey,l,p,b)$duration(l,p,b)= initial_Q_D_GEN_GEMED(ey,l,p,b) - q_ex_GEN(ey,l,p,b);
initial_P_Q_GEN_GEMED(ey,l,p,b)$initial_Q_Q_GEN_GEMED(ey,l,p,b)=( initial_Q_D_GEN_GEMED(ey,l,p,b)*initial_P_D_GEN_GEMED(ey,l,p,b) - E_EX_ENERGY_SAMDIS.l(ey,l,p,b) + electricity_mk_failures_profits_and_non_accounted_costs(ey,l,p,b) ) / initial_Q_Q_GEN_GEMED(ey,l,p,b);

initial_Q_II_GEN_SNE_GEMED(ey,l,p,b,sne)$initial_P_Q_GEN_GEMED(ey,l,p,b)=E_II_EQ_ENERGY_SAMDIS.l(ey,sne,l,p,b)/initial_P_Q_GEN_GEMED(ey,l,p,b);
initial_Q_II_GEN_TDeO_GEMED(ey,l,p,b)$initial_P_Q_GEN_GEMED(ey,l,p,b)=E_II_EE_TDeO_SAMDIS.l(ey,l,p,b)/initial_P_Q_GEN_GEMED(ey,l,p,b);
initial_Q_II_GEN_GEN_tech_GEMED(ey,l,dp,db,gp,gb,t)$initial_P_Q_GEN_GEMED(ey,l,dp,db)=E_II_EE_GEN_SAMDIS.l(ey,l,dp,db,gp,gb,t)/initial_P_Q_GEN_GEMED(ey,l,dp,db);

initial_E_G_GEMED(ey)=sum(gne,e_g_i(ey,gne,"Government"))+ sum((l,p,b), E_I_ENERGY_SAMDIS.l(ey,"Government",l,p,b)) + E_I_POWER_SAMDIS.l(ey,"Government") + sum(tx,e_tx_sam(ey,tx,"Government"))+e_i_tx(ey,"Households","Social_Contributions")+e_transf_i(ey,"Households","Government")-e_transf_i(ey,"Government","Households") + sum(sne, sum(i, e_transf_i_s(ey,i,sne))) + sum((l,p,b,t), emissions_allowance(ey,l,p,b,t)) ;
initial_Y_TAX_GEMED(ey)=sum((tx,sne),e_tx_sam(ey,tx,sne)) + sum (tx, E_TAX_E_TDeO_SAMDIS.l(ey,tx)) + sum((tx,l,p,b,t), E_TAX_E_GEN_SAMDIS.l(ey,tx,l,p,b,t)) + sum((tx,i),e_tx_sam(ey,tx,i)) + sum(tx, e_tx_sam(ey,tx,"Saves-Investments")) +  sum(tx, e_tx_sam(ey,tx,"Exports"));
initial_Y_G_GEMED(ey)=sum(pf,e_i_pf(ey,"Government",pf))+e_transf_k_ext_i(ey,"Government")-e_transf_k_i_ext(ey,"Government")+initial_Y_TAX_GEMED(ey);
initial_S_TOTAL_H_GEMED(ey)=e_i_sav(ey,"Households");
initial_S_TOTAL_G_GEMED(ey)=e_i_sav(ey,"Government");
initial_S_TOTAL_EXT_GEMED(ey)=e_sav(ey);
initial_S_TOTAL_GEMED(ey)=initial_S_TOTAL_H_GEMED(ey)+initial_S_TOTAL_G_GEMED(ey)+initial_S_TOTAL_EXT_GEMED(ey)+e_transf_k_ext_spain(ey);
initial_Q_I_D_GEMED(ey,gne)=e_inv(ey,gne) / initial_P_Q_GEMED(ey,gne);
initial_I_TOTAL_GEMED(ey)=sum(gne,initial_Q_I_D_GEMED(ey,gne)*initial_P_Q_GEMED(ey,gne)) + e_tx_sam(ey,"Product_Tax","Saves-Investments");
initial_Q_H_D_GEMED(ey,gne)=e_g_i(ey,gne,"Households")/initial_P_Q_GEMED(ey,gne);
initial_Q_H_D_GEN_GEMED(ey,l,p,b)$initial_P_Q_GEN_GEMED(ey,l,p,b)=E_I_ENERGY_SAMDIS.l(ey,"Households",l,p,b)/initial_P_Q_GEN_GEMED(ey,l,p,b);
initial_Y_H_GEMED(ey)=sum(pf,e_i_pf(ey,"Households",pf))+sum(tx,e_i_tx(ey,"Households",tx))+(e_transf_i(ey,"Households","Government")-e_transf_i(ey,"Government","Households"))+(e_transf_k_ext_i(ey,"Households")-e_transf_k_i_ext(ey,"Households"));
initial_Q_H_D_TDeO_GEMED(ey)=E_I_POWER_SAMDIS.l(ey,"Households")/initial_P_Q_TDeO_GEMED(ey);

*Using only household expenditure to define consumer price index
mu_cpi(ey,gne)= initial_Q_H_D_GEMED(ey,gne)*initial_P_Q_GEMED(ey,gne) / ( sum(gne_alias, initial_Q_H_D_GEMED(ey,gne_alias)*initial_P_Q_GEMED(ey,gne_alias)) + sum((l,p,b), initial_Q_H_D_GEN_GEMED(ey,l,p,b)*initial_P_Q_GEN_GEMED(ey,l,p,b)) + initial_Q_H_D_TDeO_GEMED(ey)*initial_P_Q_TDeO_GEMED(ey) );
mu_cpi_GEN(ey,l,p,b)= initial_Q_H_D_GEN_GEMED(ey,l,p,b)*initial_P_Q_GEN_GEMED(ey,l,p,b) / ( sum(gne, initial_Q_H_D_GEMED(ey,gne)*initial_P_Q_GEMED(ey,gne)) + sum((dp,db), initial_Q_H_D_GEN_GEMED(ey,l,dp,db)*initial_P_Q_GEN_GEMED(ey,l,dp,db)) + initial_Q_H_D_TDeO_GEMED(ey)*initial_P_Q_TDeO_GEMED(ey) );
mu_cpi_TDeO(ey)= initial_Q_H_D_TDeO_GEMED(ey)*initial_P_Q_TDeO_GEMED(ey) / ( sum(gne, initial_Q_H_D_GEMED(ey,gne)*initial_P_Q_GEMED(ey,gne)) + sum((l,p,b), initial_Q_H_D_GEN_GEMED(ey,l,p,b)*initial_P_Q_GEN_GEMED(ey,l,p,b)) + initial_Q_H_D_TDeO_GEMED(ey)*initial_P_Q_TDeO_GEMED(ey) );
initial_CPI_GEMED(ey)=sum(gne, initial_P_Q_GEMED(ey,gne)*mu_cpi(ey,gne)) + sum((l,p,b), initial_P_Q_GEN_GEMED(ey,l,p,b)*mu_cpi_GEN(ey,l,p,b)) + initial_P_Q_TDeO_GEMED(ey)*mu_cpi_TDeO(ey);

s_propensity_h(ey)=initial_S_TOTAL_H_GEMED(ey)/initial_Y_H_GEMED(ey);
c_h(ey,gne)=initial_Q_H_D_GEMED(ey,gne)*( (1+tx_rate(ey,"Households","Product_Tax"))*initial_P_Q_GEMED(ey,gne) ) / ((1-s_propensity_h(ey))*initial_Y_H_GEMED(ey) );
c_h_GEN(ey,l,p,b)$duration(l,p,b)=initial_Q_H_D_GEN_GEMED(ey,l,p,b)*( (1+tx_rate(ey,"Households","Product_Tax"))*initial_P_Q_GEN_GEMED(ey,l,p,b) ) / ( (1-s_propensity_h(ey))*initial_Y_H_GEMED(ey) );
c_h_TDeO(ey)=initial_Q_H_D_TDeO_GEMED(ey)*( (1+tx_rate(ey,"Households","Product_Tax"))*initial_P_Q_TDeO_GEMED(ey) ) / ( (1-s_propensity_h(ey))*initial_Y_H_GEMED(ey) );
q_i_pf(ey,i,"Labor")=e_i_pf(ey,i,"Labor")/initial_P_PF_LABOR_GEMED(ey);
q_i_pf(ey,i,"Capital")=e_i_pf(ey,i,"Capital")/initial_P_PF_CAPITAL_GEMED(ey);
tx_rate_sc_TDeO(ey,"Labor")=E_TAX_E_TDeO_SAMDIS.l(ey,"Social_Contributions")/E_F_E_TDeO_SAMDIS.l(ey,"Labor");
tx_rate_sc_tech(ey,"Labor",l,p,b,t)= ( E_TAX_E_GEN_SAMDIS.l(ey,"Social_Contributions",l,p,b,t)/E_F_E_GEN_SAMDIS.l(ey,"Labor",l,p,b,t) )$(E_F_E_GEN_SAMDIS.l(ey,"Labor",l,p,b,t)<>0);
tx_rate_TDeO(ey,"Product_Tax")=E_TAX_E_TDeO_SAMDIS.l(ey,"Product_Tax")/ ( sum(gne, E_II_QE_TDeO_SAMDIS.l(ey,gne)) + sum((l,p,b), E_II_EE_TDeO_SAMDIS.l(ey,l,p,b)) );
tx_rate_TDeO(ey,"Production_Taxes")=E_TAX_E_TDeO_SAMDIS.l(ey,"Production_Taxes")/ ( initial_Q_S_TDeO_GEMED(ey)*initial_P_S_TDeO_GEMED(ey) );
tx_rate_tech(ey,l,p,b,t,"Product_Tax")$initial_Q_S_TECH_GEMED(ey,l,p,b,t)=(E_TAX_E_GEN_SAMDIS.l(ey,"Product_Tax",l,p,b,t) / ( sum(gne, E_II_QE_GEN_SAMDIS.l(ey,gne,l,p,b,t)) + sum((dp,db), E_II_EE_GEN_SAMDIS.l(ey,l,dp,db,p,b,t)) ))$(( sum(gne, E_II_QE_GEN_SAMDIS.l(ey,gne,l,p,b,t)) + sum((dp,db), E_II_EE_GEN_SAMDIS.l(ey,l,dp,db,p,b,t)) )<>0);
tx_rate_GEN(ey,l,p,b,"Production_Taxes")$initial_Q_S_GEN_GEMED(ey,l,p,b)=( sum(t, E_TAX_E_GEN_SAMDIS.l(ey,"Production_Taxes",l,p,b,t)) ) /  ( initial_Q_S_GEN_GEMED(ey,l,p,b)*initial_P_S_GEN_GEMED(ey,l,p,b) );
*emission_rate_GEN(ey,l,p,b,t) = (sum(f$emitting_t(t,f), pgen_SAMDIS(ey,t,f,l,p,b)*CO2e_CONTENT_SAMDIS.l(ey,t,f)/1e6*duration(l,p,b))) / initial_Q_S_TECH_GEMED(ey,l,p,b,t);
emission_rate_GEN(ey,l,p,b,t)$initial_Q_S_TECH_GEMED(ey,l,p,b,t) = (sum(f$emitting_t(t,f), pgen_SAMDIS(ey,t,f,l,p,b)*CO2e_CONTENT_SAMDIS.l(ey,t,f)/1e6*duration(l,p,b))) / initial_Q_S_TECH_GEMED(ey,l,p,b,t);

psc_h(ey)=e_i_tx(ey,"Households","Social_Contributions")/sum(i,e_i_tx(ey,i,"Social_Contributions"));
transf_g_h(ey)=e_transf_i(ey,"Households","Government")-e_transf_i(ey,"Government","Households");
transf_ext_g(ey)=e_transf_k_ext_i(ey,"Government")-e_transf_k_i_ext(ey,"Government");
transf_ext_h(ey)=e_transf_k_ext_i(ey,"Households")-e_transf_k_i_ext(ey,"Households");
transf_ext_k(ey)=e_transf_k_ext_spain(ey);
a_va_pf(ey,"Labor",sne)= ( (1+tx_rate_sc(ey,"Labor",sne))*initial_P_PF_LABOR_GEMED(ey)*initial_Q_PF_SNE_LABOR_GEMED(ey,sne)**(1/elasticity_VA(sne)) ) / ( (1+tx_rate_sc(ey,"Labor",sne))*initial_P_PF_LABOR_GEMED(ey)*initial_Q_PF_SNE_LABOR_GEMED(ey,sne)**(1/elasticity_VA(sne)) + ( (1+tx_rate_sc(ey,"Capital",sne))*initial_P_PF_CAPITAL_GEMED(ey)*initial_Q_PF_SNE_CAPITAL_GEMED(ey,sne)**(1/elasticity_VA(sne) )));
a_va_pf(ey,"Capital",sne)= ( (1+tx_rate_sc(ey,"Capital",sne))*initial_P_PF_CAPITAL_GEMED(ey)*initial_Q_PF_SNE_CAPITAL_GEMED(ey,sne)**(1/elasticity_VA(sne) )) / ( (1+tx_rate_sc(ey,"Labor",sne))*initial_P_PF_LABOR_GEMED(ey)*initial_Q_PF_SNE_LABOR_GEMED(ey,sne)**(1/elasticity_VA(sne)) + ( (1+tx_rate_sc(ey,"Capital",sne))*initial_P_PF_CAPITAL_GEMED(ey)*initial_Q_PF_SNE_CAPITAL_GEMED(ey,sne)**(1/elasticity_VA(sne) )));
alpha_va(ey,sne)=initial_Q_VA_GEMED(ey,sne)*[ ( a_va_pf(ey,"Labor",sne)*(initial_Q_PF_SNE_LABOR_GEMED(ey,sne)**((elasticity_va(sne)-1)/elasticity_va(sne))) + a_va_pf(ey,"cAPITAL",sne)*(initial_Q_PF_SNE_CAPITAL_GEMED(ey,sne)**((elasticity_va(sne)-1)/elasticity_va(sne))) )** ( elasticity_va(sne)/(1-elasticity_va(sne)) ) ];
c_ii_share(ey,gne,sne)=initial_Q_II_GEMED(ey,gne,sne)/initial_Q_S_GEMED(ey,sne);
c_ii_share_GEN(ey,l,p,b,sne)$duration(l,p,b)= initial_Q_II_GEN_SNE_GEMED(ey,l,p,b,sne)/initial_Q_S_GEMED(ey,sne);
c_ii_share_TDeO(ey,sne)= initial_Q_II_TDeO_SNE_GEMED(ey,sne)/initial_Q_S_GEMED(ey,sne);
c_va_share(ey,sne)=initial_Q_VA_GEMED(ey,sne)/initial_Q_S_GEMED(ey,sne);
a_d_q(ey,gne)= ( ((1+tx_rate(ey,gne,"Production_Taxes"))*initial_P_S_GEMED(ey,gne)* initial_Q_S_GEMED(ey,gne)**(1/elasticity_D(gne))) ) / ( (((1+tx_rate(ey,gne,"Production_Taxes"))*initial_P_S_GEMED(ey,gne)* initial_Q_S_GEMED(ey,gne)**(1/elasticity_D(gne))))+((p_m_initial(ey,gne)* initial_Q_M_GEMED(ey,gne)**(1/elasticity_D(gne)))) );
a_d_m(ey,gne)= ( (p_m_initial(ey,gne)* initial_Q_M_GEMED(ey,gne)**(1/elasticity_D(gne))) ) / ( (((1+tx_rate(ey,gne,"Production_Taxes"))*initial_P_S_GEMED(ey,gne)* initial_Q_S_GEMED(ey,gne)**(1/elasticity_D(gne))))+((p_m_initial(ey,gne)* initial_Q_M_GEMED(ey,gne)**(1/elasticity_D(gne)))) );
alpha_d(ey,gne)= initial_Q_D_GEMED(ey,gne)* { { (a_d_q(ey,gne)*(initial_Q_S_GEMED(ey,gne)**[(elasticity_D(gne)-1)/elasticity_D(gne)])) + (a_d_m(ey,gne)*(initial_Q_M_GEMED(ey,gne)**[(elasticity_D(gne)-1)/elasticity_D(gne)])) }**[elasticity_D(gne)/(1-elasticity_D(gne))] };
b_q_q(ey,gne)=( initial_Q_EX_GEMED(ey,gne)**(1/elasticity_q(gne))*initial_P_Q_GEMED(ey,gne) ) / ( ( initial_Q_EX_GEMED(ey,gne)**(1/elasticity_q(gne))*initial_P_Q_GEMED(ey,gne) ) +  ( initial_Q_Q_GEMED(ey,gne)**(1/elasticity_q(gne))*(1+tx_rate(ey,"Exports","Product_Tax"))*p_ex_initial(ey,gne) ) );
b_q_ex(ey,gne)=1-b_q_q(ey,gne);
beta_q(ey,gne)=initial_Q_D_GEMED(ey,gne)*{ { (b_q_q(ey,gne)*(initial_Q_Q_GEMED(ey,gne)**[(elasticity_q(gne)+1)/elasticity_q(gne)])) + (b_q_ex(ey,gne)*(initial_Q_EX_GEMED(ey,gne)**[(elasticity_q(gne)+1)/elasticity_q(gne)])) }**[(-elasticity_q(gne))/(elasticity_q(gne)+1)] };
c_pf_TDeO_share(ey,"Labor")=initial_Q_PF_LABOR_TDeO_GEMED(ey)/initial_Q_VA_TDeO_GEMED(ey);
c_pf_TDeO_share(ey,"Capital")=initial_Q_PF_CAPITAL_TDeO_GEMED(ey)/initial_Q_VA_TDeO_GEMED(ey);
c_ii_gne_TDeO(ey,gne)=initial_Q_II_GNE_TDeO_GEMED(ey,gne)/initial_Q_S_TDeO_GEMED(ey);
c_ii_elec_TDeO(ey,l,p,b)$duration(l,p,b)=initial_Q_II_GEN_TDeO_GEMED(ey,l,p,b)/initial_Q_S_TDeO_GEMED(ey);
c_ii_TDeO_TDeO(ey)=initial_Q_II_TDeO_TDeO_GEMED(ey)/initial_Q_S_TDeO_GEMED(ey);
c_va_TDeO_share(ey)=initial_Q_VA_TDeO_GEMED(ey)/initial_Q_S_TDeO_GEMED(ey);
c_pf_tech_share(ey,"Labor",l,p,b,t)=( initial_Q_PF_LABOR_GEN_tech_GEMED(ey,l,p,b,t)/initial_Q_VA_GEN_tech_GEMED(ey,l,p,b,t) )$(initial_Q_VA_GEN_tech_GEMED(ey,l,p,b,t)<>0);
c_pf_tech_share(ey,"Capital",l,p,b,t)=( initial_Q_PF_CAPITAL_GEN_tech_GEMED(ey,l,p,b,t)/initial_Q_VA_GEN_tech_GEMED(ey,l,p,b,t) )$(initial_Q_VA_GEN_tech_GEMED(ey,l,p,b,t)<>0);
c_ii_gne_GEN(ey,gne,l,p,b,t)$initial_Q_S_TECH_GEMED(ey,l,p,b,t)=(initial_Q_II_GNE_GEN_tech_GEMED(ey,gne,l,p,b,t)/initial_Q_S_TECH_GEMED(ey,l,p,b,t))$(initial_Q_S_TECH_GEMED(ey,l,p,b,t)<>0);
c_ii_elec_GEN(ey,l,dp,db,gp,gb,t)$(initial_Q_S_TECH_GEMED(ey,l,gp,gb,t) and initial_Q_S_TECH_GEMED(ey,l,dp,db,t))=(initial_Q_II_GEN_GEN_tech_GEMED(ey,l,dp,db,gp,gb,t)/initial_Q_S_TECH_GEMED(ey,l,gp,gb,t))$(initial_Q_S_TECH_GEMED(ey,l,gp,gb,t)<>0);
c_ii_TDeO_GEN(ey,l,p,b,t)$initial_Q_S_TECH_GEMED(ey,l,p,b,t)=(initial_Q_II_TDeO_GEN_tech_GEMED(ey,l,p,b,t)/initial_Q_S_TECH_GEMED(ey,l,p,b,t))$(initial_Q_S_TECH_GEMED(ey,l,p,b,t)<>0);
c_va_tech_share(ey,l,p,b,t)$initial_Q_S_TECH_GEMED(ey,l,p,b,t)=(initial_Q_VA_GEN_tech_GEMED(ey,l,p,b,t)/initial_Q_S_TECH_GEMED(ey,l,p,b,t))$(initial_Q_S_TECH_GEMED(ey,l,p,b,t)<>0);
c_ii_tech_GEN(ey,l,p,b,t)$initial_Q_S_TECH_GEMED(ey,l,p,b,t)=initial_Q_S_TECH_GEMED(ey,l,p,b,t)/initial_Q_S_GEN_GEMED(ey,l,p,b);
q_gov_initial(ey,gne)=e_g_i(ey,gne,"Government")/initial_P_Q_GEMED(ey,gne);
q_gov_GEN_initial(ey,l,p,b)$duration(l,p,b)=E_I_ENERGY_SAMDIS.l(ey,"Government",l,p,b);
q_gov_TDeO_initial(ey)=E_I_POWER_SAMDIS.l(ey,"Government");
Theta(ey,gne)=(initial_Q_I_D_GEMED(ey,gne)*(1+tx_rate(ey,"Saves-Investments","Product_Tax"))*initial_P_Q_GEMED(ey,gne))/initial_I_TOTAL_GEMED(ey);

parameter propensity_scale;
propensity_scale=1;
c_h(ey,gne)=c_h(ey,gne)*propensity_scale;
c_h_GEN(ey,l,p,b)=c_h_GEN(ey,l,p,b)*propensity_scale;
c_h_TDeO(ey)=c_h_TDeO(ey)*propensity_scale;

*---------scaling parameters---------------
parameter        scale_factor    /1/;
scale_factor=1e5;
GEMED_scale_parameters(/)
*---------end of scaling parameters---------------

*---------Scalling CES Parameters---------------
*Scalling CES Parameters to avoid exagerated dimension calculations
parameters
         scaleparameter_a_VA(ey,sne)
         scaleparameter_a_D(ey,gne)
         scaleparameter_b_EX(ey,gne);

         scaleparameter_a_VA(ey,sne)=1;
         scaleparameter_a_D(ey,gne)=1;
         scaleparameter_b_EX(ey,gne)=1;

         scaleparameter_a_VA(ey,sne)$((a_va_pf(ey,"Labor",sne)*a_va_pf(ey,"Capital",sne)) lt 1e-3) = min(a_va_pf(ey,"Labor",sne),a_va_pf(ey,"Capital",sne))*1e3;
         a_va_pf(ey,"Labor",sne)=a_va_pf(ey,"Labor",sne)/scaleparameter_a_VA(ey,sne);
         a_va_pf(ey,"Capital",sne)=a_va_pf(ey,"Capital",sne)/scaleparameter_a_VA(ey,sne);
         alpha_va(ey,sne)=alpha_va(ey,sne)*scaleparameter_a_VA(ey,sne)**[elasticity_va(sne)/(elasticity_va(sne)-1)];

         scaleparameter_a_D(ey,gne)$((a_d_q(ey,gne)*a_d_m(ey,gne)) lt 1e-3) = min(a_d_q(ey,gne),a_d_m(ey,gne))*1e3;
         a_d_q(ey,gne)=a_d_q(ey,gne)/scaleparameter_a_D(ey,gne);
         a_d_m(ey,gne)=a_d_m(ey,gne)/scaleparameter_a_D(ey,gne);
         alpha_d(ey,gne)=alpha_d(ey,gne)*scaleparameter_a_D(ey,gne)**[elasticity_d(gne)/(elasticity_d(gne)-1)];

         scaleparameter_b_EX(ey,gne) $((b_q_q(ey,gne)*b_q_ex(ey,gne)) lt 1e-3) = min(b_q_q(ey,gne),b_q_ex(ey,gne))*1e3;
         b_q_q(ey,gne)=b_q_q(ey,gne)/scaleparameter_b_EX(ey,gne);
         b_q_ex(ey,gne)=b_q_ex(ey,gne)/scaleparameter_b_EX(ey,gne);
         beta_q(ey,gne)=beta_q(ey,gne)*scaleparameter_b_EX(ey,gne)**[elasticity_q(gne)/(elasticity_q(gne)+1)];

         display scaleparameter_a_VA, scaleparameter_a_D, scaleparameter_b_EX;
*---------------------------------------------------


*-------------------------------------------------------------------------------
*------------------------------------- Variables -------------------------------
*-------------------------------------------------------------------------------
Variables
Q_H_D_GEMED(y,gne)       Household domestic non electricity goods demand
Q_H_D_GEN_GEMED(y,l,p,b) Household domestic electricity goods demand at location l - season p and load block b
Q_H_D_TDeO_GEMED(y)      Household domestic electricity goods demand of transmission distribution and other electricity services
P_PF_LABOR_GEMED(y)      Price of production factor labor
P_PF_CAPITAL_GEMED(y)    Price of production factor capital
Y_H_GEMED(y)             Total household income
Q_PF_SNE_LABOR_GEMED(y,sne) Quantity of production factor labor
Q_PF_SNE_CAPITAL_GEMED(y,sne) Quantity of production factor capital
Q_VA_GEMED(y,sne)        Quantity of value added composite good produced by non electricity sector sne
P_VA_GEMED(y,sne)        Price of value added composite good of a specific non electricity sector sne
Q_II_GEMED(y,gne,sne)    Quantity of non electricity intermediary input gne utilized by a specific non electricity sector sne
Q_II_GEN_SNE_GEMED(y,l,p,b,sne)  Quantity of electricity good intermediary input at location l - season p and load block b utilized by a specific non electricity sector sne
Q_II_TDeO_SNE_GEMED(y,sne)  Quantity of transmission distribution and other electricity services intermediary input utilized by a specific non electricity sector sne
Q_S_GEMED(y,sne)         Quantity of the commodity produced by a specific non electricity sector sne
P_S_GEMED(y,gne)         Price of commodity produced by a specific non electricity sector sne (without foreign aggregations and production taxes)
Q_M_GEMED(y,gne)         Quantity of non electricity good gne imported from the exterior
Q_D_GEMED(y,gne)         Quantity of aggregated imported and domestic produced supply of non electricity good gne
P_D_GEMED(y,gne)         Price of Armington aggregated price of the non electricity good gne
Q_EX_GEMED(y,gne)        Quantity of non electricity goods gne exported to the exterior
Q_Q_GEMED(y,gne)         Quantity of final domestic market supply of non electricity good gne
P_Q_GEMED(y,gne)         Price of final domestic non electricity good gne
Q_PF_LABOR_TDeO_GEMED(y) Quantity of production factor labor used in the transmission distribution and other electricity services
Q_PF_CAPITAL_TDeO_GEMED(y) Quantity of production factor capital used in the transmission distribution and other electricity services
Q_VA_TDeO_GEMED(y)       Quantity of value added composite good produced by the transmission distribution and other electricity services
P_VA_TDeO_GEMED(y)       Price of value added composite good of the transmission distribution and other electricity services
Q_II_GNE_TDeO_GEMED(y,gne) Quantity of non electricity intermediary input gne utilized by the transmission distribution and other electricity services
Q_II_GEN_TDeO_GEMED(y,l,dp,db) Quantity of electricity good intermediary input at location l - season dp and load block db utilized by the transmission distribution and other electricity services
Q_II_TDeO_TDeO_GEMED(y)  Quantity of transmission distribution and other electricity services good intermediary input utilized by the electricity transmission distribution and other electricity services
Q_S_TDeO_GEMED(y)        Quantity of the commodity produced by the transmission distribution and other electricity services
P_S_TDeO_GEMED(y)        Price of commodity produced by the transmission distribution and other electricity services (without foreign aggregations and production taxes)
Q_D_TDeO_GEMED(y)        Quantity of aggregated imported and domestic produced supply of transmission distribution and other electricity services
P_D_TDeO_GEMED(y)        Price of aggregated transmission distribution and other electricity services
Q_Q_TDeO_GEMED(y)        Quantity of final domestic market supply of transmission distribution and other electricity services
P_Q_TDeO_GEMED(y)        Price of final domestic transmission distribution and other electricity services
Q_PF_LABOR_GEN_tech_GEMED(y,l,p,b,t) Quantity of production factor labor used in the electricity sector at location l - season p and load block b
Q_PF_CAPITAL_GEN_tech_GEMED(y,l,p,b,t) Quantity of production factor capital used in the electricity sector at location l - season p and load block b
Q_VA_GEN_tech_GEMED(y,l,p,b,t) Quantity of value added composite good produced by the electricity sector at location l - season p and load block b
P_VA_GEN_tech_GEMED(y,l,p,b,t) Price of value added composite good of the electricity sector at location l - season p and load block b
Q_II_GNE_GEN_tech_GEMED(y,gne,l,p,b,t) Quantity of non electricity intermediary input gne utilized by the electricity sector at location l - season p and load block b
Q_II_GEN_GEN_tech_GEMED(y,l,dp,db,gp,gb,t) Quantity of electricity good intermediary input at location l - season dp and load block db utilized by the electricity sector at season gp and load block gb
Q_II_TDeO_GEN_tech_GEMED(y,l,p,b,t) Quantity of electricity transmission distribution and other electricity services good intermediary input utilized by the electricity sector at season gp and load block gb
Q_S_TECH_GEMED(y,l,p,b,t)  Quantity of the commodity produced by the electricity technology t at location l - season p and load block b
P_S_TECH_GEMED(y,l,p,b,t)  Price of commodity produced by the electricity technology t at location l - season p and load block b (without foreign aggregations and production taxes)
Q_S_GEN_GEMED(y,l,p,b)   Quantity of the commodity produced by the electricity sector at location l - season p and load block b
P_S_GEN_GEMED(y,l,p,b)   Price of commodity produced by the electricity sector at location l - season p and load block b (without foreign aggregations and production taxes)
Q_D_GEN_GEMED(y,l,p,b)   Quantity of aggregated imported and domestic produced supply of electricity good at location l - season p and load block b
P_D_GEN_GEMED(y,l,p,b)   Price of aggregated electricity good at location l - season p and load block b
Q_Q_GEN_GEMED(y,l,p,b)   Quantity of final domestic market supply of electricity good at location l - season p and load block b
P_Q_GEN_GEMED(y,l,p,b)   Price of final domestic electricity good at location l - season p and load block b
Y_G_GEMED(y)             Total government income
E_G_GEMED(y)             Total government expenditure
Y_TAX_GEMED(y)           Total government taxes income
S_TOTAL_GEMED(y)         Total economy savings
S_TOTAL_H_GEMED(y)       Households savings
S_TOTAL_G_GEMED(y)       Government savings
S_TOTAL_EXT_GEMED(y)     Foreign total savings
I_TOTAL_GEMED(y)         Total investment
Q_I_D_GEMED(y,gne)       Quantity of non electricity good gne demanded as investment good (electricity cannot be a investment good because it is not storable)
CPI_GEMED(y)             Numeraire
DUMMY_GEMED              Dummy variable used on NLP solution
WALRAS_GEMED(y)          Walras check variable applied to savings investments equality

*Case study variables
INCREASED_DR_LOAD_GEMED(y,l,p,b)
DECREASED_DR_LOAD_GEMED(y,l,p,b)
CONSERVED_DR_LOAD_GEMED(y,l,p,b)
LAMBDA_DR_MAX_DISPLACEMENT(ey,l,p,b)
LAMBDA_DR_BALANCE(ey,l,p)
LAMBDA_DR_MAX_CONSERVATION(ey,l,p,b)
LAMBDA_DR_MIN_SAVINGS(ey,l,p)
;


Positive Variables
Q_H_D_GEMED, Q_H_D_GEN_GEMED, Q_H_D_TDeO_GEMED, P_PF_LABOR_GEMED, P_PF_CAPITAL_GEMED,
Y_H_GEMED, Q_PF_SNE_LABOR_GEMED, Q_PF_SNE_CAPITAL_GEMED, Q_VA_GEMED, P_VA_GEMED,
Q_II_GEMED, Q_II_GEN_SNE_GEMED, Q_II_TDeO_SNE_GEMED, Q_S_GEMED, P_S_GEMED, Q_M_GEMED,
Q_D_GEMED, P_D_GEMED, Q_Q_GEMED, P_Q_GEMED, Q_PF_LABOR_TDeO_GEMED, Q_PF_CAPITAL_TDeO_GEMED,
Q_VA_TDeO_GEMED, P_VA_TDeO_GEMED, Q_II_GNE_TDeO_GEMED,Q_II_GEN_TDeO_GEMED,Q_II_TDeO_TDeO_GEMED,
Q_S_TDeO_GEMED,P_S_TDeO_GEMED,Q_D_TDeO_GEMED,P_D_TDeO_GEMED,Q_Q_TDeO_GEMED,P_Q_TDeO_GEMED,
Q_PF_LABOR_GEN_tech_GEMED,Q_PF_CAPITAL_GEN_tech_GEMED,Q_VA_GEN_tech_GEMED,
P_VA_GEN_tech_GEMED, Q_II_GNE_GEN_tech_GEMED,Q_II_GEN_GEN_tech_GEMED,
Q_II_TDeO_GEN_tech_GEMED, Q_S_TECH_GEMED, P_S_TECH_GEMED, Q_S_GEN_GEMED, P_S_GEN_GEMED,
Q_D_GEN_GEMED, P_D_GEN_GEMED, Q_Q_GEN_GEMED, P_Q_GEN_GEMED, Y_G_GEMED,E_G_GEMED,
Y_TAX_GEMED,S_TOTAL_GEMED,S_TOTAL_H_GEMED,S_TOTAL_G_GEMED, S_TOTAL_EXT_GEMED,I_TOTAL_GEMED,Q_I_D_GEMED

INCREASED_DR_LOAD_GEMED,DECREASED_DR_LOAD_GEMED,CONSERVED_DR_LOAD_GEMED
;

Negative Variables
LAMBDA_DR_MAX_DISPLACEMENT, LAMBDA_DR_BALANCE, LAMBDA_DR_MAX_CONSERVATION, LAMBDA_DR_MIN_SAVINGS
;

*-------------------------------------------------------------------------------
*----------------------------- Defining Model Equations ------------------------
*-------------------------------------------------------------------------------
Equations
eq_6_3_1(ey,gne)
eq_6_3_2(ey,l,p,b)
eq_6_3_3(ey)
eq_6_3_4(ey)
eq_6_3_5(ey)
eq_6_3_6(ey,sne)
eq_6_3_7(ey,sne)
eq_6_3_8(ey,sne)
eq_6_3_9(ey,gne,sne)
eq_6_3_10(ey,l,p,b,sne)
eq_6_3_11(ey,sne)
eq_6_3_12(ey,sne)
eq_6_3_13(ey,sne)
eq_6_3_14(ey,gne)
eq_6_3_15(ey,gne)
eq_6_3_16(ey,gne)
eq_6_3_17(ey,gne)
eq_6_3_18(ey,gne)
eq_6_3_19(ey,gne)
eq_6_3_20_a(ey)
eq_6_3_20_b(ey)
eq_6_3_21(ey)
eq_6_3_22(ey,gne)
eq_6_3_23(ey,l,dp,db)
eq_6_3_24(ey)
eq_6_3_25(ey)
eq_6_3_26(ey)
eq_6_3_27(ey)
eq_6_3_28(ey)
eq_6_3_29(ey)
eq_6_3_30(ey)
eq_6_3_31_a(ey,l,p,b,t)
eq_6_3_31_b(ey,l,p,b,t)
eq_6_3_32(ey,l,p,b,t)
eq_6_3_33(ey,gne,l,p,b,t)
eq_6_3_34(ey,l,dp,db,gp,gb,t)
eq_6_3_35(ey,l,gp,gb,t)
eq_6_3_36(ey,l,p,b,t)
eq_6_3_37(ey,l,p,b,t)
eq_6_3_38(ey,l,gp,gb,t)
eq_6_3_39(ey,l,gp,gb)
eq_6_3_40(ey,l,p,b)
eq_6_3_41(ey,l,p,b)
eq_6_3_42(ey,l,p,b)
eq_6_3_43(ey,l,p,b)
eq_6_3_44(ey)
eq_6_3_45(ey)
eq_6_3_46(ey)
eq_6_3_47(ey)
eq_6_3_48(ey)
eq_6_3_49(ey)
eq_6_3_50(ey,gne)
eq_6_3_51_a(ey)
eq_6_3_51_b(ey)
eq_6_3_52(ey,gne)
eq_6_3_53(ey,l,p,b)
eq_6_3_54(ey)
eq_6_3_55(ey)
eq_CPI(ey)
eq_object_function_GEMED

*case study equations
eq_6_3_42_case_study(ey,l,p,b)

eq_dL_dINCREASED_DR_LOAD_GEMED(y,l,p,b)
eq_dL_dDECREASED_DR_LOAD_GEMED(y,l,p,b)
eq_dL_dCONSERVED_DR_LOAD_GEMED(y,l,p,b)
eq_maximum_displacement_case_study(ey,l,p,b)
eq_displacement_balance_case_study(ey,l,p)
eq_potency_conservation_limit_case_study(ey,l,p,b)
eq_minimal_savings_requirement_case_study(ey,l,p)
;

*********************************************
eq_6_3_1(ey,gne)..
Q_H_D_GEMED(ey,gne)=e= ( c_h(ey,gne)/propensity_scale*(1-s_propensity_h(ey))*Y_H_GEMED(ey) ) / ( (1+tx_rate(ey,"Households","Product_Tax"))*P_Q_GEMED(ey,gne) );

eq_6_3_2(ey,l,p,b)..
Q_H_D_GEN_GEMED(ey,l,p,b) * ( (1+tx_rate(ey,"Households","Product_Tax"))*P_Q_GEN_GEMED(ey,l,p,b) ) =e= ( c_h_GEN(ey,l,p,b)/propensity_scale*(1-s_propensity_h(ey))*Y_H_GEMED(ey) );

eq_6_3_3(ey)..
Q_H_D_TDeO_GEMED(ey) =e= ( c_h_TDeO(ey)/propensity_scale*(1-s_propensity_h(ey))*Y_H_GEMED(ey) ) / ( (1+tx_rate(ey,"Households","Product_Tax"))*P_Q_TDeO_GEMED(ey) );

eq_6_3_4(ey)..
Y_H_GEMED(ey)=e=q_i_pf(ey,"Households","Labor")*P_PF_LABOR_GEMED(ey) + q_i_pf(ey,"Households","Capital")*P_PF_CAPITAL_GEMED(ey)+transf_g_h(ey)+psc_h(ey)* ( sum((sne),(tx_rate_sc(ey,"Labor",sne))*P_PF_LABOR_GEMED(ey)*Q_PF_SNE_LABOR_GEMED(ey,sne))+tx_rate_sc_TDeO(ey,"Labor")*P_PF_LABOR_GEMED(ey)*Q_PF_LABOR_TDeO_GEMED(ey)+sum((l,p,b,t),(tx_rate_sc_tech(ey,"Labor",l,p,b,t))*P_PF_LABOR_GEMED(ey)*Q_PF_LABOR_GEN_tech_GEMED(ey,l,p,b,t)) )+transf_ext_h(ey);

eq_6_3_5(ey)..
S_TOTAL_H_GEMED(ey)=e=s_propensity_h(ey)*Y_H_GEMED(ey);

*********************************************
eq_6_3_6(ey,sne)..
(Q_PF_SNE_LABOR_GEMED(ey,sne)**(1/elasticity_va(sne)))*a_va_pf(ey,"Capital",sne)*(1+tx_rate_sc(ey,"Labor",sne))*P_PF_LABOR_GEMED(ey)=e=(Q_PF_SNE_CAPITAL_GEMED(ey,sne)**(1/elasticity_va(sne)))*a_va_pf(ey,"Labor",sne)*P_PF_CAPITAL_GEMED(ey);

eq_6_3_7(ey,sne)..
Q_VA_GEMED(ey,sne)=e=alpha_va(ey,sne)*[ ( (a_va_pf(ey,"Labor",sne)*(Q_PF_SNE_LABOR_GEMED(ey,sne)**((elasticity_va(sne)-1)/elasticity_va(sne)))) + (a_va_pf(ey,"Capital",sne)*(Q_PF_SNE_CAPITAL_GEMED(ey,sne)**((elasticity_va(sne)-1)/elasticity_va(sne)))) )** ( elasticity_va(sne)/(elasticity_va(sne)-1) ) ];

eq_6_3_8(ey,sne)..
Q_VA_GEMED(ey,sne)*P_VA_GEMED(ey,sne)=e= (1+tx_rate_sc(ey,"Labor",sne))*Q_PF_SNE_LABOR_GEMED(ey,sne)*P_PF_LABOR_GEMED(ey) + Q_PF_SNE_CAPITAL_GEMED(ey,sne)*P_PF_CAPITAL_GEMED(ey);

eq_6_3_9(ey,gne,sne)..
Q_II_GEMED(ey,gne,sne)=e=c_ii_share(ey,gne,sne)*Q_S_GEMED(ey,sne);

eq_6_3_10(ey,l,p,b,sne)..
Q_II_GEN_SNE_GEMED(ey,l,p,b,sne) =e= c_ii_share_GEN(ey,l,p,b,sne)*Q_S_GEMED(ey,sne);

eq_6_3_11(ey,sne)..
Q_II_TDeO_SNE_GEMED(ey,sne) =e= c_ii_share_TDeO(ey,sne)*Q_S_GEMED(ey,sne);

eq_6_3_12(ey,sne)..
Q_VA_GEMED(ey,sne)=e=c_va_share(ey,sne)*Q_S_GEMED(ey,sne);

eq_6_3_13(ey,sne)..
Q_S_GEMED(ey,sne)*P_S_GEMED(ey,sne)+sum(i,e_transf_i_s(ey,i,sne))=e= Q_VA_GEMED(ey,sne)*P_VA_GEMED(ey,sne) + sum(gne, Q_II_GEMED(ey,gne,sne)*(1+tx_rate(ey,sne,"Product_tax"))*P_Q_GEMED(ey,gne)) + sum((l,p,b), Q_II_GEN_SNE_GEMED(ey,l,p,b,sne)*(1+tx_rate(ey,sne,"Product_tax"))*P_Q_GEN_GEMED(ey,l,p,b)) + Q_II_TDeO_SNE_GEMED(ey,sne)*(1+tx_rate(ey,sne,"Product_tax"))*P_Q_TDeO_GEMED(ey)+ emission_rate(ey,sne)*Q_S_GEMED(ey,sne)*co2_price(ey);

eq_6_3_14(ey,gne)..
(Q_S_GEMED(ey,gne)**(1/elasticity_d(gne)))*a_d_m(ey,gne)*(1+tx_rate(ey,gne,"Production_taxes"))*P_S_GEMED(ey,gne)=e=(Q_M_GEMED(ey,gne)**(1/elasticity_d(gne)))*a_d_q(ey,gne)*p_m_initial(ey,gne);

eq_6_3_15(ey,gne)..
Q_D_GEMED(ey,gne)=e=  alpha_d(ey,gne)*[ ( a_d_q(ey,gne)*(Q_S_GEMED(ey,gne)**((elasticity_d(gne)-1)/elasticity_d(gne))) +  a_d_m(ey,gne)*(Q_M_GEMED(ey,gne)**((elasticity_d(gne)-1)/elasticity_d(gne))) )** ( elasticity_d(gne)/(elasticity_d(gne)-1) ) ];

eq_6_3_16(ey,gne)..
Q_D_GEMED(ey,gne)*P_D_GEMED(ey,gne)=e=(1+tx_rate(ey,gne,"Production_taxes"))*P_S_GEMED(ey,gne)*Q_S_GEMED(ey,gne) + p_m_initial(ey,gne)*Q_M_GEMED(ey,gne);

eq_6_3_17(ey,gne)..
Q_Q_GEMED(ey,gne)*(b_q_q(ey,gne)**elasticity_q(gne))*(((1+tx_rate(ey,"Exports","Product_Tax"))*p_ex_initial(ey,gne))**elasticity_q(gne))=e=Q_EX_GEMED(ey,gne)*(b_q_ex(ey,gne)**elasticity_q(gne))*(P_Q_GEMED(ey,gne)**elasticity_q(gne));

eq_6_3_18(ey,gne)..
Q_D_GEMED(ey,gne)=e= beta_q(ey,gne)*[ ( b_q_q(ey,gne)*(Q_Q_GEMED(ey,gne)**((elasticity_q(gne)+1)/elasticity_q(gne))) + b_q_ex(ey,gne)*(Q_EX_GEMED(ey,gne)**((elasticity_q(gne)+1)/elasticity_q(gne))) )** ( elasticity_q(gne)/(elasticity_q(gne)+1) ) ];

eq_6_3_19(ey,gne)..
Q_D_GEMED(ey,gne)*P_D_GEMED(ey,gne)=e=Q_Q_GEMED(ey,gne)*P_Q_GEMED(ey,gne) + p_ex_initial(ey,gne)*Q_EX_GEMED(ey,gne);

*********************************************
eq_6_3_20_a(ey)..
Q_PF_LABOR_TDeO_GEMED(ey)=e=Q_VA_TDeO_GEMED(ey)*c_pf_TDeO_share(ey,"Labor");

eq_6_3_20_b(ey)..
Q_PF_CAPITAL_TDeO_GEMED(ey)=e=Q_VA_TDeO_GEMED(ey)*c_pf_TDeO_share(ey,"Capital");

eq_6_3_21(ey)..
Q_VA_TDeO_GEMED(ey)*P_VA_TDeO_GEMED(ey)=e=(1+tx_rate_sc_TDeO(ey,"Labor"))*P_PF_LABOR_GEMED(ey)*Q_PF_LABOR_TDeO_GEMED(ey) +  P_PF_CAPITAL_GEMED(ey)*Q_PF_CAPITAL_TDeO_GEMED(ey);

eq_6_3_22(ey,gne)..
Q_S_TDeO_GEMED(ey)*c_ii_gne_TDeO(ey,gne)=e=Q_II_GNE_TDeO_GEMED(ey,gne);

eq_6_3_23(ey,l,dp,db)..
Q_S_TDeO_GEMED(ey)*c_ii_elec_TDeO(ey,l,dp,db)=e=Q_II_GEN_TDeO_GEMED(ey,l,dp,db);

eq_6_3_24(ey)..
Q_S_TDeO_GEMED(ey)*c_ii_TDeO_TDeO(ey)=e=Q_II_TDeO_TDeO_GEMED(ey);

eq_6_3_25(ey)..
Q_S_TDeO_GEMED(ey)*c_va_TDeO_share(ey)=e=Q_VA_TDeO_GEMED(ey);

eq_6_3_26(ey)..
P_S_TDeO_GEMED(ey)*Q_S_TDeO_GEMED(ey)=e=P_VA_TDeO_GEMED(ey)*Q_VA_TDeO_GEMED(ey)+sum(gne, (1+tx_rate_TDeO(ey,"Product_tax"))*P_Q_GEMED(ey,gne)*Q_II_GNE_TDeO_GEMED(ey,gne))+ sum((l,dp,db), (1+tx_rate_TDeO(ey,"Product_tax"))*P_Q_GEN_GEMED(ey,l,dp,db)*Q_II_GEN_TDeO_GEMED(ey,l,dp,db))  + Q_II_TDeO_TDeO_GEMED(ey)*(1+tx_rate_TDeO(ey,"Product_tax"))*P_Q_TDeO_GEMED(ey);

eq_6_3_27(ey)..
Q_D_TDeO_GEMED(ey) =e= Q_S_TDeO_GEMED(ey);

eq_6_3_28(ey)..
P_D_TDeO_GEMED(ey)*Q_D_TDeO_GEMED(ey) =e= (1+tx_rate_TDeO(ey,"Production_taxes"))*P_S_TDeO_GEMED(ey)*Q_S_TDeO_GEMED(ey);

eq_6_3_29(ey)..
Q_Q_TDeO_GEMED(ey) =e= Q_D_TDeO_GEMED(ey);

eq_6_3_30(ey)..
P_Q_TDeO_GEMED(ey)*Q_Q_TDeO_GEMED(ey) =e= P_D_TDeO_GEMED(ey)*Q_D_TDeO_GEMED(ey);

*********************************************
eq_6_3_31_a(ey,l,p,b,t)..
Q_PF_LABOR_GEN_tech_GEMED(ey,l,p,b,t)=e=Q_VA_GEN_tech_GEMED(ey,l,p,b,t)*c_pf_tech_share(ey,"Labor",l,p,b,t);

eq_6_3_31_b(ey,l,p,b,t)..
Q_PF_CAPITAL_GEN_tech_GEMED(ey,l,p,b,t)=e=Q_VA_GEN_tech_GEMED(ey,l,p,b,t)*c_pf_tech_share(ey,"Capital",l,p,b,t);

eq_6_3_32(ey,l,p,b,t)..
Q_VA_GEN_tech_GEMED(ey,l,p,b,t)*P_VA_GEN_tech_GEMED(ey,l,p,b,t)=e=(1+tx_rate_sc_tech(ey,"Labor",l,p,b,t))*P_PF_LABOR_GEMED(ey)*Q_PF_LABOR_GEN_tech_GEMED(ey,l,p,b,t) +  P_PF_CAPITAL_GEMED(ey)*Q_PF_CAPITAL_GEN_tech_GEMED(ey,l,p,b,t);

eq_6_3_33(ey,gne,l,p,b,t)..
Q_S_TECH_GEMED(ey,l,p,b,t)*c_ii_gne_GEN(ey,gne,l,p,b,t)=e=Q_II_GNE_GEN_tech_GEMED(ey,gne,l,p,b,t);

eq_6_3_34(ey,l,dp,db,gp,gb,t)..
Q_S_TECH_GEMED(ey,l,gp,gb,t)*c_ii_elec_GEN(ey,l,dp,db,gp,gb,t)=e=Q_II_GEN_GEN_tech_GEMED(ey,l,dp,db,gp,gb,t);

eq_6_3_35(ey,l,gp,gb,t)..
Q_S_TECH_GEMED(ey,l,gp,gb,t)*c_ii_TDeO_GEN(ey,l,gp,gb,t)=e=Q_II_TDeO_GEN_tech_GEMED(ey,l,gp,gb,t);

eq_6_3_36(ey,l,p,b,t)..
Q_S_TECH_GEMED(ey,l,p,b,t)*c_va_tech_share(ey,l,p,b,t)=e=Q_VA_GEN_tech_GEMED(ey,l,p,b,t);

eq_6_3_37(ey,l,p,b,t)..
*P_S_TECH_GEMED(ey,l,p,b,t)*Q_S_TECH_GEMED(ey,l,p,b,t)=e=P_VA_GEN_tech_GEMED(ey,l,p,b,t)*Q_VA_GEN_tech_GEMED(ey,l,p,b,t)+sum(gne, (1+tx_rate_tech(ey,l,p,b,t,"Product_tax"))*P_Q_GEMED(ey,gne)*Q_II_GNE_GEN_tech_GEMED(ey,gne,l,p,b,t))+ (1+tx_rate_tech(ey,l,p,b,t,"Product_tax"))*P_Q_TDeO_GEMED(ey)*Q_II_TDeO_GEN_tech_GEMED(ey,l,p,b,t) + sum((dp,db), (1+tx_rate_tech(ey,l,p,b,t,"Product_tax"))*P_Q_GEN_GEMED(ey,l,dp,db)*Q_II_GEN_GEN_tech_GEMED(ey,l,dp,db,p,b,t)) + emission_rate_GEN(ey,l,p,b,t)*co2_price(ey)*initial_Q_S_TECH_GEMED(ey,l,p,b,t) - emissions_allowance(ey,l,p,b,t);
P_S_TECH_GEMED(ey,l,p,b,t)*Q_S_TECH_GEMED(ey,l,p,b,t)=e=P_VA_GEN_tech_GEMED(ey,l,p,b,t)*Q_VA_GEN_tech_GEMED(ey,l,p,b,t)+sum(gne, (1+tx_rate_tech(ey,l,p,b,t,"Product_tax"))*P_Q_GEMED(ey,gne)*Q_II_GNE_GEN_tech_GEMED(ey,gne,l,p,b,t))+ (1+tx_rate_tech(ey,l,p,b,t,"Product_tax"))*P_Q_TDeO_GEMED(ey)*Q_II_TDeO_GEN_tech_GEMED(ey,l,p,b,t) + sum((dp,db), (1+tx_rate_tech(ey,l,p,b,t,"Product_tax"))*P_Q_GEN_GEMED(ey,l,dp,db)*Q_II_GEN_GEN_tech_GEMED(ey,l,dp,db,p,b,t)) + emission_rate_GEN(ey,l,p,b,t)*co2_price(ey)*Q_S_TECH_GEMED(ey,l,p,b,t);

eq_6_3_38(ey,l,p,b,t)..
Q_S_GEN_GEMED(ey,l,p,b)*c_ii_tech_GEN(ey,l,p,b,t)=e=Q_S_TECH_GEMED(ey,l,p,b,t);

eq_6_3_39(ey,l,p,b)..
$ontext
P_S_GEN_GEMED(ey,l,p,b)*Q_S_GEN_GEMED(ey,l,p,b) =e= sum(t, P_S_TECH_GEMED(ey,l,p,b,t)*Q_S_TECH_GEMED(ey,l,p,b,t))
*- emissions_allowance(ey,l,p,b)
+ electricity_mk_failures_profits_and_non_accounted_costs(ey,l,p,b);
$offtext
P_S_GEN_GEMED(ey,l,p,b)*Q_S_GEN_GEMED(ey,l,p,b) =e= sum(t, P_S_TECH_GEMED(ey,l,p,b,t)*Q_S_TECH_GEMED(ey,l,p,b,t))
- sum(t, emissions_allowance(ey,l,p,b,t))
*+ electricity_mk_failures_profits_and_non_accounted_costs(ey,l,p,b);
;

eq_6_3_40(ey,l,p,b)..
Q_D_GEN_GEMED(ey,l,p,b) =e= Q_S_GEN_GEMED(ey,l,p,b)+q_m_GEN(ey,l,p,b);

eq_6_3_41(ey,l,p,b)..
P_D_GEN_GEMED(ey,l,p,b)*Q_D_GEN_GEMED(ey,l,p,b) =e= (1+tx_rate_GEN(ey,l,p,b,"Production_taxes"))*P_S_GEN_GEMED(ey,l,p,b)*Q_S_GEN_GEMED(ey,l,p,b)+ p_m_GEN(ey,l,p,b)*q_m_GEN(ey,l,p,b);

eq_6_3_42(ey,l,p,b)..
Q_Q_GEN_GEMED(ey,l,p,b) =e= Q_D_GEN_GEMED(ey,l,p,b) - q_ex_GEN(ey,l,p,b);

eq_6_3_43(ey,l,p,b)..
P_Q_GEN_GEMED(ey,l,p,b)*Q_Q_GEN_GEMED(ey,l,p,b) =e= P_D_GEN_GEMED(ey,l,p,b)*Q_D_GEN_GEMED(ey,l,p,b) - p_ex_GEN(ey,l,p,b)*q_ex_GEN(ey,l,p,b)
+ electricity_mk_failures_profits_and_non_accounted_costs(ey,l,p,b);

*********************************************
eq_6_3_44(ey)..
Y_G_GEMED(ey)=e=q_i_pf(ey,"Government","Labor")*P_PF_LABOR_GEMED(ey) + q_i_pf(ey,"Government","Capital")*P_PF_CAPITAL_GEMED(ey)+transf_ext_g(ey)+Y_TAX_GEMED(ey);

eq_6_3_45(ey)..
E_G_GEMED(ey)=e=sum(gne,(1+tx_rate(ey,"Government","Product_Tax"))*P_Q_GEMED(ey,gne)*q_gov_initial(ey,gne))+sum((l,p,b),(1+tx_rate(ey,"Government","Product_Tax"))*P_Q_GEN_GEMED(ey,l,p,b)*q_gov_GEN_initial(ey,l,p,b))+(1+tx_rate(ey,"Government","Product_Tax"))*P_Q_TDeO_GEMED(ey)*q_gov_TDeO_initial(ey)+transf_g_h(ey)+psc_h(ey)* ( sum((sne),(tx_rate_sc(ey,"Labor",sne))*P_PF_LABOR_GEMED(ey)*Q_PF_SNE_LABOR_GEMED(ey,sne))+sum((l,p,b,t),(tx_rate_sc_tech(ey,"Labor",l,p,b,t))*P_PF_LABOR_GEMED(ey)*Q_PF_LABOR_GEN_tech_GEMED(ey,l,p,b,t))+tx_rate_sc_TDeO(ey,"Labor")*P_PF_LABOR_GEMED(ey)*Q_PF_LABOR_TDeO_GEMED(ey) )+sum(sne, sum(i,e_transf_i_s(ey,i,sne)))+sum((l,p,b,t), emissions_allowance(ey,l,p,b,t));

eq_6_3_46(ey)..
S_TOTAL_G_GEMED(ey)=e=Y_G_GEMED(ey)-E_G_GEMED(ey);

eq_6_3_47(ey)..
Y_TAX_GEMED(ey)=e=
sum((sne),(tx_rate_sc(ey,"Labor",sne))*P_PF_LABOR_GEMED(ey)*Q_PF_SNE_LABOR_GEMED(ey,sne))+
tx_rate_sc_TDeO(ey,"Labor")*P_PF_LABOR_GEMED(ey)*Q_PF_LABOR_TDeO_GEMED(ey)+
sum((l,p,b,t),(tx_rate_sc_tech(ey,"Labor",l,p,b,t))*P_PF_LABOR_GEMED(ey)*Q_PF_LABOR_GEN_tech_GEMED(ey,l,p,b,t))+
sum(sne, sum(gne, tx_rate(ey,sne,"Product_tax")*P_Q_GEMED(ey,gne)*Q_II_GEMED(ey,gne,sne))) +
sum(gne, tx_rate_TDeO(ey,"Product_tax")*P_Q_GEMED(ey,gne)*Q_II_GNE_TDeO_GEMED(ey,gne)) +
sum((l,p,b,t), sum(gne, tx_rate_tech(ey,l,p,b,t,"Product_tax")*P_Q_GEMED(ey,gne)*Q_II_GNE_GEN_tech_GEMED(ey,gne,l,p,b,t)) ) +
sum(sne$ets_sne(sne), emission_rate(ey,sne)*Q_S_GEMED(ey,sne)*co2_price(ey))      +
sum((l,p,b,t), emission_rate_GEN(ey,l,p,b,t)*co2_price(ey)*Q_S_TECH_GEMED(ey,l,p,b,t) ) +
sum(sne, tx_rate(ey,sne,"Product_tax")*P_Q_TDeO_GEMED(ey)*Q_II_TDeO_SNE_GEMED(ey,sne)) +
tx_rate_TDeO(ey,"Product_tax")*P_Q_TDeO_GEMED(ey)*Q_II_TDeO_TDeO_GEMED(ey) +
sum((l,p,b,t), tx_rate_tech(ey,l,p,b,t,"Product_tax")*P_Q_TDeO_GEMED(ey)*Q_II_TDeO_GEN_tech_GEMED(ey,l,p,b,t)) +
sum(sne, sum((l,p,b), tx_rate(ey,sne,"Product_tax")*P_Q_GEN_GEMED(ey,l,p,b)*Q_II_GEN_SNE_GEMED(ey,l,p,b,sne))) +
sum((l,p,b), tx_rate_TDeO(ey,"Product_tax")*P_Q_GEN_GEMED(ey,l,p,b)*Q_II_GEN_TDeO_GEMED(ey,l,p,b)) +
sum((l,p,b,t), sum((dp,db), tx_rate_tech(ey,l,p,b,t,"Product_tax")*P_Q_GEN_GEMED(ey,l,dp,db)*Q_II_GEN_GEN_tech_GEMED(ey,l,dp,db,p,b,t)) ) +
sum(sne,tx_rate(ey,sne,"Production_taxes")*P_S_GEMED(ey,sne)*Q_S_GEMED(ey,sne)) +
tx_rate_TDeO(ey,"Production_taxes")*P_S_TDeO_GEMED(ey)*Q_S_TDeO_GEMED(ey) +
sum((l,p,b),tx_rate_GEN(ey,l,p,b,"Production_taxes")*P_S_GEN_GEMED(ey,l,p,b)*Q_S_GEN_GEMED(ey,l,p,b)) +
sum(gne,tx_rate(ey,"Exports","Product_Tax")*p_ex_initial(ey,gne)*Q_EX_GEMED(ey,gne)) +
sum((l,p,b),tx_rate(ey,"Exports","Product_Tax")*p_ex_GEN(ey,l,p,b)*q_ex_GEN(ey,l,p,b)) +
sum(gne, tx_rate(ey,"Households","Product_Tax")*P_Q_GEMED(ey,gne)*Q_H_D_GEMED(ey,gne)) +
sum((l,p,b), tx_rate(ey,"Households","Product_Tax")*P_Q_GEN_GEMED(ey,l,p,b)*Q_H_D_GEN_GEMED(ey,l,p,b)) +
tx_rate(ey,"Households","Product_Tax")*P_Q_TDeO_GEMED(ey)*Q_H_D_TDeO_GEMED(ey) +
sum(gne,tx_rate(ey,"Government","Product_Tax")*P_Q_GEMED(ey,gne)*q_gov_initial(ey,gne)) +
sum((l,p,b),tx_rate(ey,"Government","Product_Tax")*P_Q_GEN_GEMED(ey,l,p,b)*q_gov_GEN_initial(ey,l,p,b)) +
tx_rate(ey,"Government","Product_Tax")*P_Q_TDeO_GEMED(ey)*q_gov_TDeO_initial(ey) +
sum(gne,tx_rate(ey,"Saves-Investments","Product_Tax")*P_Q_GEMED(ey,gne)*Q_I_D_GEMED(ey,gne));

*********************************************  

eq_6_3_48(ey)..
S_TOTAL_GEMED(ey)=e=S_TOTAL_H_GEMED(ey)+S_TOTAL_G_GEMED(ey)+S_TOTAL_EXT_GEMED(ey)+transf_ext_k(ey);

eq_6_3_49(ey)..
S_TOTAL_EXT_GEMED(ey)=e=sum(gne,p_m_initial(ey,gne)*Q_M_GEMED(ey,gne))+sum((l,p,b),p_m_GEN(ey,l,p,b)*q_m_GEN(ey,l,p,b))-sum(gne,(1+tx_rate(ey,"Exports","Product_tax"))*p_ex_initial(ey,gne)*Q_EX_GEMED(ey,gne)) -sum((l,p,b),(1+tx_rate(ey,"Exports","Product_tax"))*p_ex_GEN(ey,l,p,b)*q_ex_GEN(ey,l,p,b))-transf_ext_g(ey)-transf_ext_h(ey)-transf_ext_k(ey);

eq_6_3_50(ey,gne)..
Theta(ey,gne)*I_TOTAL_GEMED(ey)=e=Q_I_D_GEMED(ey,gne)*((1+tx_rate(ey,"Saves-Investments","Product_Tax"))*P_Q_GEMED(ey,gne));

*********************************************

eq_6_3_51_a(ey)..
sum(sne, Q_PF_SNE_LABOR_GEMED(ey,sne)) + sum((l,p,b,t), Q_PF_LABOR_GEN_tech_GEMED(ey,l,p,b,t)) + Q_PF_LABOR_TDeO_GEMED(ey) =e=sum(i,q_i_pf(ey,i,"Labor"));

eq_6_3_51_b(ey)..
sum(sne, Q_PF_SNE_CAPITAL_GEMED(ey,sne)) + sum((l,p,b,t), Q_PF_CAPITAL_GEN_tech_GEMED(ey,l,p,b,t)) + Q_PF_CAPITAL_TDeO_GEMED(ey)+ sum((l,p,b),electricity_mk_failures_profits_and_non_accounted_costs(ey,l,p,b)/P_PF_CAPITAL_GEMED(ey)) =e=sum(i,q_i_pf(ey,i,"Capital"));
*sum(sne, Q_PF_SNE_CAPITAL_GEMED(ey,sne)) + sum((l,p,b,t), Q_PF_CAPITAL_GEN_tech_GEMED(ey,l,p,b,t)) + Q_PF_CAPITAL_TDeO_GEMED(ey) =e=sum(i,q_i_pf(ey,i,"Capital"));

eq_6_3_52(ey,gne)..
Q_Q_GEMED(ey,gne)=e=Q_H_D_GEMED(ey,gne)+q_gov_initial(ey,gne)+sum(sne,Q_II_GEMED(ey,gne,sne))+sum((l,p,b,t),Q_II_GNE_GEN_tech_GEMED(ey,gne,l,p,b,t))+ Q_II_GNE_TDeO_GEMED(ey,gne) +Q_I_D_GEMED(ey,gne);

eq_6_3_53(ey,l,p,b)..
Q_Q_GEN_GEMED(ey,l,p,b)=e=Q_H_D_GEN_GEMED(ey,l,p,b)+q_gov_GEN_initial(ey,l,p,b)+sum(sne,Q_II_GEN_SNE_GEMED(ey,l,p,b,sne))+sum((gp,gb,t),Q_II_GEN_GEN_tech_GEMED(ey,l,p,b,gp,gb,t))+ Q_II_GEN_TDeO_GEMED(ey,l,p,b);

eq_6_3_54(ey)..
Q_Q_TDeO_GEMED(ey)=e=Q_H_D_TDeO_GEMED(ey)+q_gov_TDeO_initial(ey)+sum(sne,Q_II_TDeO_SNE_GEMED(ey,sne))+sum((l,p,b,t),Q_II_TDeO_GEN_tech_GEMED(ey,l,p,b,t))+Q_II_TDeO_TDeO_GEMED(ey);

eq_6_3_55(ey)..
I_TOTAL_GEMED(ey)=e=S_TOTAL_GEMED(ey) + WALRAS_GEMED(ey);

*---------Consumer price Index-------------------------
eq_CPI(ey)..
CPI_GEMED(ey) =e= sum(gne, P_Q_GEMED(ey,gne)*mu_cpi(ey,gne)) + sum((l,p,b), P_Q_GEN_GEMED(ey,l,p,b)*mu_cpi_GEN(ey,l,p,b)) + P_Q_TDeO_GEMED(ey)*mu_cpi_TDeO(ey);

*-------Objective function for NLP resolution----------
eq_object_function_GEMED..
DUMMY_GEMED =e= 1;




*---------GAD Case Study-------------------------
eq_6_3_42_case_study(ey,l,p,b)..
Q_Q_GEN_GEMED(ey,l,p,b) =e= Q_D_GEN_GEMED(ey,l,p,b) - q_ex_GEN(ey,l,p,b) + ( INCREASED_DR_LOAD_GEMED(ey,l,p,b)*duration(l,p,b) - DECREASED_DR_LOAD_GEMED(ey,l,p,b)*duration(l,p,b) )$(exec_DR_displac) - ( CONSERVED_DR_LOAD_GEMED(ey,l,p,b)*duration(l,p,b) )$(exec_DR_reduc);

eq_dL_dINCREASED_DR_LOAD_GEMED(ey,l,p,b)..
duration(l,p,b)*P_Q_GEN_GEMED(ey,l,p,b)- LAMBDA_DR_BALANCE(ey,l,p)*duration(l,p,b) + LAMBDA_DR_MIN_SAVINGS(ey,l,p)*duration(l,p,b)*P_Q_GEN_GEMED(ey,l,p,b)=e=0;

eq_dL_dDECREASED_DR_LOAD_GEMED(ey,l,p,b)..
- duration(l,p,b)*P_Q_GEN_GEMED(ey,l,p,b)- LAMBDA_DR_MAX_DISPLACEMENT(ey,l,p,b)+ LAMBDA_DR_BALANCE(ey,l,p)*duration(l,p,b)- LAMBDA_DR_MIN_SAVINGS(ey,l,p)*duration(l,p,b)*P_Q_GEN_GEMED(ey,l,p,b)=e=0;

eq_dL_dCONSERVED_DR_LOAD_GEMED(ey,l,p,b)..
- duration(l,p,b)*P_Q_GEN_GEMED(ey,l,p,b) - LAMBDA_DR_MAX_CONSERVATION(ey,l,p,b) =e= 0;

eq_maximum_displacement_case_study(ey,l,p,b) $ (exec_DR_displac and duration(l,p,b))..
DECREASED_DR_LOAD_GEMED(ey,l,p,b) =l= displaceable_load(ey,l,p,b);

eq_displacement_balance_case_study(ey,l,p) $ (exec_DR_displac)..
sum(b, INCREASED_DR_LOAD_GEMED(ey,l,p,b)*duration(l,p,b) ) =e= sum(b, DECREASED_DR_LOAD_GEMED(ey,l,p,b)*duration(l,p,b));

eq_potency_conservation_limit_case_study(ey,l,p,b) $ (exec_DR_reduc and duration(l,p,b))..
CONSERVED_DR_LOAD_GEMED(ey,l,p,b) =l= conservable_load(ey,l,p,b);

eq_minimal_savings_requirement_case_study(ey,l,p) $ (exec_DR_displac)..
sum(b, ( DECREASED_DR_LOAD_GEMED(ey,l,p,b)*duration(l,p,b) )*P_Q_GEN_GEMED(ey,l,p,b))-sum(b, ( INCREASED_DR_LOAD_GEMED(ey,l,p,b)*duration(l,p,b) )*P_Q_GEN_GEMED(ey,l,p,b))=l=(1-minimum_required_DR_savings(ey))*sum(b, ( displaceable_load(ey,l,p,b)*duration(l,p,b) )*initial_P_Q_GEN_GEMED(ey,l,p,b));




*-------------------------------------------------------------------------------
*-------------------------------- Defining CGE Model ---------------------------
*-------------------------------------------------------------------------------
* initializing variables ---------------------------------------------
P_PF_LABOR_GEMED.l(ey)=initial_P_PF_LABOR_GEMED(ey);
P_PF_CAPITAL_GEMED.l(ey)=initial_P_PF_CAPITAL_GEMED(ey);
P_VA_GEMED.l(ey,sne)=initial_P_VA_GEMED(ey,sne);
P_S_GEMED.l(ey,gne)=initial_P_S_GEMED(ey,gne);
P_D_GEMED.l(ey,gne)=initial_P_D_GEMED(ey,gne);
P_Q_GEMED.l(ey,gne)=initial_P_Q_GEMED(ey,gne);
P_VA_TDeO_GEMED.l(ey)=initial_P_VA_TDeO_GEMED(ey);
P_S_TDeO_GEMED.l(ey)=initial_P_S_TDeO_GEMED(ey);
P_D_TDeO_GEMED.l(ey)=initial_P_D_TDeO_GEMED(ey);
P_Q_TDeO_GEMED.l(ey)=initial_P_Q_TDeO_GEMED(ey);
P_VA_GEN_tech_GEMED.l(ey,l,p,b,t)=initial_P_VA_GEN_tech_GEMED(ey,l,p,b,t);
P_S_TECH_GEMED.l(ey,l,p,b,t)=initial_P_S_TECH_GEMED(ey,l,p,b,t);
P_S_GEN_GEMED.l(ey,l,p,b)=initial_P_S_GEN_GEMED(ey,l,p,b);
P_D_GEN_GEMED.l(ey,l,p,b)=initial_P_D_GEN_GEMED(ey,l,p,b);
P_Q_GEN_GEMED.l(ey,l,p,b)=initial_P_Q_GEN_GEMED(ey,l,p,b);
Q_H_D_GEMED.l(ey,gne)=initial_Q_H_D_GEMED(ey,gne);
Q_H_D_GEN_GEMED.l(ey,l,p,b)=initial_Q_H_D_GEN_GEMED(ey,l,p,b);
Q_H_D_TDeO_GEMED.l(ey)=initial_Q_H_D_TDeO_GEMED(ey);
Y_H_GEMED.l(ey)=initial_Y_H_GEMED(ey);
Q_PF_SNE_LABOR_GEMED.l(ey,sne)=initial_Q_PF_SNE_LABOR_GEMED(ey,sne);
Q_PF_SNE_CAPITAL_GEMED.l(ey,sne)=initial_Q_PF_SNE_CAPITAL_GEMED(ey,sne);
Q_VA_GEMED.l(ey,sne)=initial_Q_VA_GEMED(ey,sne);
Q_II_GEMED.l(ey,gne,sne)=initial_Q_II_GEMED(ey,gne,sne);
Q_II_GEN_SNE_GEMED.l(ey,l,p,b,sne)=initial_Q_II_GEN_SNE_GEMED(ey,l,p,b,sne);
Q_II_TDeO_SNE_GEMED.l(ey,sne)=initial_Q_II_TDeO_SNE_GEMED(ey,sne);
Q_S_GEMED.l(ey,sne)=initial_Q_S_GEMED(ey,sne);
Q_M_GEMED.l(ey,gne)=initial_Q_M_GEMED(ey,gne);
Q_D_GEMED.l(ey,gne)=initial_Q_D_GEMED(ey,gne);
Q_EX_GEMED.l(ey,gne)=initial_Q_EX_GEMED(ey,gne);
Q_Q_GEMED.l(ey,gne)=initial_Q_Q_GEMED(ey,gne);
Q_PF_LABOR_TDeO_GEMED.l(ey)=initial_Q_PF_LABOR_TDeO_GEMED(ey);
Q_PF_CAPITAL_TDeO_GEMED.l(ey)=initial_Q_PF_CAPITAL_TDeO_GEMED(ey);
Q_VA_TDeO_GEMED.l(ey)=initial_Q_VA_TDeO_GEMED(ey);
Q_II_GNE_TDeO_GEMED.l(ey,gne)=initial_Q_II_GNE_TDeO_GEMED(ey,gne);
Q_II_GEN_TDeO_GEMED.l(ey,l,dp,db)=initial_Q_II_GEN_TDeO_GEMED(ey,l,dp,db);
Q_II_TDeO_TDeO_GEMED.l(ey)=initial_Q_II_TDeO_TDeO_GEMED(ey);
Q_S_TDeO_GEMED.l(ey)=initial_Q_S_TDeO_GEMED(ey);
Q_D_TDeO_GEMED.l(ey)=initial_Q_D_TDeO_GEMED(ey);
Q_Q_TDeO_GEMED.l(ey)=initial_Q_Q_TDeO_GEMED(ey);
Q_PF_LABOR_GEN_tech_GEMED.l(ey,l,p,b,t)=initial_Q_PF_LABOR_GEN_tech_GEMED(ey,l,p,b,t);
Q_PF_CAPITAL_GEN_tech_GEMED.l(ey,l,p,b,t)=initial_Q_PF_CAPITAL_GEN_tech_GEMED(ey,l,p,b,t);
Q_VA_GEN_tech_GEMED.l(ey,l,p,b,t)=initial_Q_VA_GEN_tech_GEMED(ey,l,p,b,t);
Q_II_GNE_GEN_tech_GEMED.l(ey,gne,l,p,b,t)=initial_Q_II_GNE_GEN_tech_GEMED(ey,gne,l,p,b,t);
Q_II_GEN_GEN_tech_GEMED.l(ey,l,dp,db,gp,gb,t)=initial_Q_II_GEN_GEN_tech_GEMED(ey,l,dp,db,gp,gb,t);
Q_II_TDeO_GEN_tech_GEMED.l(ey,l,p,b,t)=initial_Q_II_TDeO_GEN_tech_GEMED(ey,l,p,b,t);
Q_S_TECH_GEMED.l(ey,l,p,b,t)=initial_Q_S_TECH_GEMED(ey,l,p,b,t);
Q_S_GEN_GEMED.l(ey,l,p,b)=initial_Q_S_GEN_GEMED(ey,l,p,b);
Q_D_GEN_GEMED.l(ey,l,p,b)=initial_Q_D_GEN_GEMED(ey,l,p,b);
Q_Q_GEN_GEMED.l(ey,l,p,b)=initial_Q_Q_GEN_GEMED(ey,l,p,b);
E_G_GEMED.l(ey)=initial_E_G_GEMED(ey);
Y_TAX_GEMED.l(ey)=initial_Y_TAX_GEMED(ey);
Y_G_GEMED.l(ey)=initial_Y_G_GEMED(ey);
S_TOTAL_H_GEMED.l(ey)=initial_S_TOTAL_H_GEMED(ey);
S_TOTAL_G_GEMED.l(ey)=initial_S_TOTAL_G_GEMED(ey);
S_TOTAL_EXT_GEMED.l(ey)=initial_S_TOTAL_EXT_GEMED(ey);
S_TOTAL_GEMED.l(ey)=initial_S_TOTAL_GEMED(ey);
Q_I_D_GEMED.l(ey,gne)=initial_Q_I_D_GEMED(ey,gne);
I_TOTAL_GEMED.l(ey)=initial_I_TOTAL_GEMED(ey);
CPI_GEMED.l(ey)=initial_CPI_GEMED(ey);
DUMMY_GEMED.l=1;


$ontext
* Setting lower bounds to avoid vcPower: GRAD SINGULAR: x**c, x=0, 0<c<1 ---------
parameter lower_bound /1e-15/;
Q_H_D_GEMED.lo(ey,gne)=lower_bound;
Q_H_D_GEN_GEMED.lo(ey,l,p,b)=lower_bound;
Q_H_D_TDeO_GEMED.lo(ey)=lower_bound;
P_PF_LABOR_GEMED.lo(ey)=lower_bound;
P_PF_CAPITAL_GEMED.lo(ey)=lower_bound;
Y_H_GEMED.lo(ey)=lower_bound;
Q_PF_SNE_LABOR_GEMED.lo(ey,sne)=lower_bound;
Q_PF_SNE_CAPITAL_GEMED.lo(ey,sne)=lower_bound;
Q_VA_GEMED.lo(ey,sne)=lower_bound;
P_VA_GEMED.lo(ey,sne)=lower_bound;
Q_II_GEMED.lo(ey,gne,sne)=lower_bound;
Q_II_GEN_SNE_GEMED.lo(ey,l,p,b,sne)=lower_bound;
Q_II_TDeO_SNE_GEMED.lo(ey,sne)=lower_bound;
Q_S_GEMED.lo(ey,sne)=lower_bound;
P_S_GEMED.lo(ey,gne)=lower_bound;
Q_M_GEMED.lo(ey,gne)=lower_bound;
Q_D_GEMED.lo(ey,gne)=lower_bound;
P_D_GEMED.lo(ey,gne)=lower_bound;
Q_EX_GEMED.lo(ey,gne)=lower_bound;
Q_Q_GEMED.lo(ey,gne)=lower_bound;
P_Q_GEMED.lo(ey,gne)=lower_bound;
Q_PF_LABOR_TDeO_GEMED.lo(ey)=lower_bound;
Q_PF_CAPITAL_TDeO_GEMED.lo(ey)=lower_bound;
Q_VA_TDeO_GEMED.lo(ey)=lower_bound;
P_VA_TDeO_GEMED.lo(ey)=lower_bound;
Q_II_GNE_TDeO_GEMED.lo(ey,gne)=lower_bound;
Q_II_GEN_TDeO_GEMED.lo(ey,l,dp,db)=lower_bound;
Q_II_TDeO_TDeO_GEMED.lo(ey)=lower_bound;
Q_S_TDeO_GEMED.lo(ey)=lower_bound;
P_S_TDeO_GEMED.lo(ey)=lower_bound;
Q_D_TDeO_GEMED.lo(ey)=lower_bound;
P_D_TDeO_GEMED.lo(ey)=lower_bound;
Q_Q_TDeO_GEMED.lo(ey)=lower_bound;
P_Q_TDeO_GEMED.lo(ey)=lower_bound;
Q_PF_LABOR_GEN_tech_GEMED.lo(ey,l,p,b,t)=lower_bound;
Q_PF_CAPITAL_GEN_tech_GEMED.lo(ey,l,p,b,t)=lower_bound;
Q_VA_GEN_tech_GEMED.lo(ey,l,p,b,t)=lower_bound;
P_VA_GEN_tech_GEMED.lo(ey,l,p,b,t)=lower_bound;
Q_II_GNE_GEN_tech_GEMED.lo(ey,gne,l,p,b,t)=lower_bound;
Q_II_GEN_GEN_tech_GEMED.lo(ey,l,dp,db,gp,gb,t)=lower_bound;
Q_II_TDeO_GEN_tech_GEMED.lo(ey,l,p,b,t)=lower_bound;
Q_S_TECH_GEMED.lo(ey,l,p,b,t)=lower_bound;
P_S_TECH_GEMED.lo(ey,l,p,b,t)=lower_bound;
Q_S_GEN_GEMED.lo(ey,l,p,b)=lower_bound;
P_S_GEN_GEMED.lo(ey,l,p,b)=lower_bound;
Q_D_GEN_GEMED.lo(ey,l,p,b)=lower_bound;
P_D_GEN_GEMED.lo(ey,l,p,b)=lower_bound;
Q_Q_GEN_GEMED.lo(ey,l,p,b)=lower_bound;
P_Q_GEN_GEMED.lo(ey,l,p,b)=lower_bound;
Y_G_GEMED.lo(ey)=lower_bound;
E_G_GEMED.lo(ey)=lower_bound;
Y_TAX_GEMED.lo(ey)=lower_bound;
S_TOTAL_GEMED.lo(ey)=lower_bound;
S_TOTAL_H_GEMED.lo(ey)=lower_bound;
S_TOTAL_G_GEMED.lo(ey)=lower_bound;
S_TOTAL_EXT_GEMED.lo(ey)=lower_bound;
I_TOTAL_GEMED.lo(ey)=lower_bound;
Q_I_D_GEMED.lo(ey,gne)=lower_bound;
$offtext

$ontext
*---------Fixing non used load blocks--------------------
loop((l,p,b)$(not duration(l,p,b)),
Q_H_D_GEN_GEMED.fx(ey,l,p,b)=lower_bound;
Q_II_GEN_SNE_GEMED.fx(ey,l,p,b,sne)=lower_bound;
Q_II_GEN_TDeO_GEMED.fx(ey,l,dp,db)=lower_bound;
Q_PF_LABOR_GEN_tech_GEMED.fx(ey,l,p,b,t)=lower_bound;
Q_PF_CAPITAL_GEN_tech_GEMED.fx(ey,l,p,b,t)=lower_bound;
Q_VA_GEN_tech_GEMED.fx(ey,l,p,b,t)=lower_bound;
P_VA_GEN_tech_GEMED.fx(ey,l,p,b,t)=lower_bound;
Q_II_GNE_GEN_tech_GEMED.fx(ey,gne,l,p,b,t)=lower_bound;
Q_II_GEN_GEN_tech_GEMED.fx(ey,l,dp,db,gp,gb,t)=lower_bound;
Q_II_TDeO_GEN_tech_GEMED.fx(ey,l,p,b,t)=lower_bound;
Q_S_TECH_GEMED.fx(ey,l,p,b,t)=lower_bound;
P_S_TECH_GEMED.fx(ey,l,p,b,t)=lower_bound;
Q_S_GEN_GEMED.fx(ey,l,p,b)=lower_bound;
P_S_GEN_GEMED.fx(ey,l,p,b)=lower_bound;
Q_D_GEN_GEMED.fx(ey,l,p,b)=lower_bound;
P_D_GEN_GEMED.fx(ey,l,p,b)=lower_bound;
Q_Q_GEN_GEMED.fx(ey,l,p,b)=lower_bound;
P_Q_GEN_GEMED.fx(ey,l,p,b)=lower_bound;
);
$offtext

* numeraire ---------------------------------------------
CPI_GEMED.fx(ey)=initial_CPI_GEMED(ey);

* NLP Model -------------------------------------------------
Model GEMED_NLP /
                 eq_6_3_1, eq_6_3_2, eq_6_3_3, eq_6_3_4, eq_6_3_5, eq_6_3_6,
                 eq_6_3_7, eq_6_3_8, eq_6_3_9, eq_6_3_10, eq_6_3_11, eq_6_3_12,
                 eq_6_3_13, eq_6_3_14, eq_6_3_15, eq_6_3_16, eq_6_3_17, eq_6_3_18,
                 eq_6_3_19, eq_6_3_20_a, eq_6_3_20_b, eq_6_3_21, eq_6_3_22,
                 eq_6_3_23, eq_6_3_24, eq_6_3_25, eq_6_3_26, eq_6_3_27, eq_6_3_28,
                 eq_6_3_29, eq_6_3_30, eq_6_3_31_a, eq_6_3_31_b, eq_6_3_32,
                 eq_6_3_33, eq_6_3_34, eq_6_3_35, eq_6_3_36, eq_6_3_37, eq_6_3_38,
                 eq_6_3_39, eq_6_3_40, eq_6_3_41, eq_6_3_42, eq_6_3_43, eq_6_3_44,
                 eq_6_3_45, eq_6_3_46, eq_6_3_47, eq_6_3_48, eq_6_3_49, eq_6_3_50,
                 eq_6_3_51_a, eq_6_3_51_b, eq_6_3_52, eq_6_3_53, eq_6_3_54, eq_6_3_55, eq_CPI,eq_object_function_GEMED
                /;

* MCP Model -------------------------------------------------
Model GEMED_MCP /
                 eq_6_3_1.Q_H_D_GEMED, eq_6_3_2.Q_H_D_GEN_GEMED, eq_6_3_3.Q_H_D_TDeO_GEMED,
                 eq_6_3_4.Y_H_GEMED, eq_6_3_5.S_TOTAL_H_GEMED, eq_6_3_6.Q_PF_SNE_LABOR_GEMED,
                 eq_6_3_7.Q_PF_SNE_CAPITAL_GEMED, eq_6_3_8.Q_VA_GEMED, eq_6_3_9.Q_II_GEMED,
                 eq_6_3_10.Q_II_GEN_SNE_GEMED, eq_6_3_11.Q_II_TDeO_SNE_GEMED, eq_6_3_12.P_VA_GEMED,
                 eq_6_3_13.Q_S_GEMED, eq_6_3_14.Q_M_GEMED, eq_6_3_15.P_S_GEMED,
                 eq_6_3_16.Q_D_GEMED, eq_6_3_17.Q_EX_GEMED, eq_6_3_18.P_D_GEMED,
                 eq_6_3_19.Q_Q_GEMED, eq_6_3_20_a.Q_PF_LABOR_TDeO_GEMED, eq_6_3_20_b.Q_PF_CAPITAL_TDeO_GEMED,
                 eq_6_3_21.Q_VA_TDeO_GEMED, eq_6_3_22.Q_II_GNE_TDeO_GEMED, eq_6_3_23.Q_II_GEN_TDeO_GEMED,
                 eq_6_3_24.Q_II_TDeO_TDeO_GEMED, eq_6_3_25.P_VA_TDeO_GEMED, eq_6_3_26.Q_S_TDeO_GEMED,
                 eq_6_3_27.P_S_TDeO_GEMED, eq_6_3_28.Q_D_TDeO_GEMED, eq_6_3_29.P_D_TDeO_GEMED,
                 eq_6_3_30.Q_Q_TDeO_GEMED, eq_6_3_31_a.Q_PF_LABOR_GEN_tech_GEMED,
                 eq_6_3_31_b.Q_PF_CAPITAL_GEN_tech_GEMED, eq_6_3_32.Q_VA_GEN_tech_GEMED,
                 eq_6_3_33.Q_II_GNE_GEN_tech_GEMED, eq_6_3_34.Q_II_GEN_GEN_tech_GEMED,
                 eq_6_3_35.Q_II_TDeO_GEN_tech_GEMED, eq_6_3_36.P_VA_GEN_tech_GEMED,
                 eq_6_3_37.Q_S_TECH_GEMED, eq_6_3_38.P_S_TECH_GEMED, eq_6_3_39.Q_S_GEN_GEMED,
                 eq_6_3_40.P_S_GEN_GEMED, eq_6_3_41.Q_D_GEN_GEMED,
                 eq_6_3_42.P_D_GEN_GEMED, eq_6_3_43.Q_Q_GEN_GEMED, eq_6_3_44.Y_G_GEMED,
                 eq_6_3_45.E_G_GEMED, eq_6_3_46.S_TOTAL_G_GEMED, eq_6_3_47.Y_TAX_GEMED,
                 eq_6_3_48.S_TOTAL_GEMED, eq_6_3_49.S_TOTAL_EXT_GEMED, eq_6_3_50.Q_I_D_GEMED,
                 eq_6_3_51_a.P_PF_LABOR_GEMED, eq_6_3_51_b.P_PF_CAPITAL_GEMED, eq_6_3_52.P_Q_GEMED,
                 eq_6_3_53.P_Q_GEN_GEMED, eq_6_3_54.P_Q_TDeO_GEMED, eq_6_3_55.I_TOTAL_GEMED, eq_CPI.CPI_GEMED
                /;



* MCP Model -------------------------------------------------
Model GEMED_MCP_GAD /
                 eq_6_3_1.Q_H_D_GEMED, eq_6_3_2.Q_H_D_GEN_GEMED, eq_6_3_3.Q_H_D_TDeO_GEMED,
                 eq_6_3_4.Y_H_GEMED, eq_6_3_5.S_TOTAL_H_GEMED, eq_6_3_6.Q_PF_SNE_LABOR_GEMED,
                 eq_6_3_7.Q_PF_SNE_CAPITAL_GEMED, eq_6_3_8.Q_VA_GEMED, eq_6_3_9.Q_II_GEMED,
                 eq_6_3_10.Q_II_GEN_SNE_GEMED, eq_6_3_11.Q_II_TDeO_SNE_GEMED, eq_6_3_12.P_VA_GEMED,
                 eq_6_3_13.Q_S_GEMED, eq_6_3_14.Q_M_GEMED, eq_6_3_15.P_S_GEMED,
                 eq_6_3_16.Q_D_GEMED, eq_6_3_17.Q_EX_GEMED, eq_6_3_18.P_D_GEMED,
                 eq_6_3_19.Q_Q_GEMED, eq_6_3_20_a.Q_PF_LABOR_TDeO_GEMED, eq_6_3_20_b.Q_PF_CAPITAL_TDeO_GEMED,
                 eq_6_3_21.Q_VA_TDeO_GEMED, eq_6_3_22.Q_II_GNE_TDeO_GEMED, eq_6_3_23.Q_II_GEN_TDeO_GEMED,
                 eq_6_3_24.Q_II_TDeO_TDeO_GEMED, eq_6_3_25.P_VA_TDeO_GEMED, eq_6_3_26.Q_S_TDeO_GEMED,
                 eq_6_3_27.P_S_TDeO_GEMED, eq_6_3_28.Q_D_TDeO_GEMED, eq_6_3_29.P_D_TDeO_GEMED,
                 eq_6_3_30.Q_Q_TDeO_GEMED, eq_6_3_31_a.Q_PF_LABOR_GEN_tech_GEMED,
                 eq_6_3_31_b.Q_PF_CAPITAL_GEN_tech_GEMED, eq_6_3_32.Q_VA_GEN_tech_GEMED,
                 eq_6_3_33.Q_II_GNE_GEN_tech_GEMED, eq_6_3_34.Q_II_GEN_GEN_tech_GEMED,
                 eq_6_3_35.Q_II_TDeO_GEN_tech_GEMED, eq_6_3_36.P_VA_GEN_tech_GEMED,
                 eq_6_3_37.Q_S_TECH_GEMED, eq_6_3_38.P_S_TECH_GEMED, eq_6_3_39.Q_S_GEN_GEMED,
                 eq_6_3_40.P_S_GEN_GEMED, eq_6_3_41.Q_D_GEN_GEMED,
*                 eq_6_3_42.P_D_GEN_GEMED,
                 eq_6_3_43.Q_Q_GEN_GEMED, eq_6_3_44.Y_G_GEMED,
                 eq_6_3_45.E_G_GEMED, eq_6_3_46.S_TOTAL_G_GEMED, eq_6_3_47.Y_TAX_GEMED,
                 eq_6_3_48.S_TOTAL_GEMED, eq_6_3_49.S_TOTAL_EXT_GEMED, eq_6_3_50.Q_I_D_GEMED,
                 eq_6_3_51_a.P_PF_LABOR_GEMED, eq_6_3_51_b.P_PF_CAPITAL_GEMED, eq_6_3_52.P_Q_GEMED,
                 eq_6_3_53.P_Q_GEN_GEMED, eq_6_3_54.P_Q_TDeO_GEMED, eq_6_3_55.I_TOTAL_GEMED, eq_CPI.CPI_GEMED

                 eq_6_3_42_case_study.P_D_GEN_GEMED,
                 eq_dL_dINCREASED_DR_LOAD_GEMED.INCREASED_DR_LOAD_GEMED,
                 eq_dL_dDECREASED_DR_LOAD_GEMED.DECREASED_DR_LOAD_GEMED,
                 eq_dL_dCONSERVED_DR_LOAD_GEMED.CONSERVED_DR_LOAD_GEMED,
                 eq_maximum_displacement_case_study.LAMBDA_DR_MAX_DISPLACEMENT,
                 eq_displacement_balance_case_study.LAMBDA_DR_BALANCE,
                 eq_potency_conservation_limit_case_study.LAMBDA_DR_MAX_CONSERVATION,
                 eq_minimal_savings_requirement_case_study.LAMBDA_DR_MIN_SAVINGS
                /;


*-------------------------------------------------------------------------------


WALRAS_GEMED.fx(ey)=0;
GEMED_NLP.HOLDFIXED= 1;
GEMED_MCP.HOLDFIXED= 1;
GEMED_MCP_GAD.HOLDFIXED= 1;
*OPTION ITERLIM = 0;
option limcol = 1000;
option limrow = 1000;
option nlp=conopt;
option mcp=path;





